"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _compose = _interopRequireDefault(require("recompose/compose"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _raCore = require("ra-core");

var _Button = _interopRequireDefault(require("./Button"));

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var basePath = _ref.basePath,
      dispatchCrudDeleteMany = _ref.dispatchCrudDeleteMany,
      filterValues = _ref.filterValues,
      label = _ref.label,
      resource = _ref.resource,
      selectedIds = _ref.selectedIds,
      startUndoable = _ref.startUndoable,
      undoable = _ref.undoable,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["basePath", "dispatchCrudDeleteMany", "filterValues", "label", "resource", "selectedIds", "startUndoable", "undoable"]);
  return rest;
};

var BulkDeleteButton = function (_Component) {
  (0, _inherits2.default)(BulkDeleteButton, _Component);

  function BulkDeleteButton() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, BulkDeleteButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(BulkDeleteButton)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleClick", function () {
      var _this$props = _this.props,
          basePath = _this$props.basePath,
          dispatchCrudDeleteMany = _this$props.dispatchCrudDeleteMany,
          resource = _this$props.resource,
          selectedIds = _this$props.selectedIds,
          startUndoable = _this$props.startUndoable,
          undoable = _this$props.undoable,
          onClick = _this$props.onClick;

      if (undoable) {
        startUndoable((0, _raCore.crudDeleteMany)(resource, selectedIds, basePath));
      } else {
        dispatchCrudDeleteMany(resource, selectedIds, basePath);
      }

      if (typeof onClick === 'function') {
        onClick();
      }
    });
    return _this;
  }

  (0, _createClass2.default)(BulkDeleteButton, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          label = _this$props2.label,
          icon = _this$props2.icon,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["label", "icon"]);
      return _react.default.createElement(_Button.default, (0, _extends2.default)({
        onClick: this.handleClick,
        label: label
      }, sanitizeRestProps(rest)), icon);
    }
  }]);
  return BulkDeleteButton;
}(_react.Component);

(0, _defineProperty2.default)(BulkDeleteButton, "propTypes", {
  basePath: _propTypes.default.string,
  dispatchCrudDeleteMany: _propTypes.default.func.isRequired,
  label: _propTypes.default.string,
  resource: _propTypes.default.string.isRequired,
  startUndoable: _propTypes.default.func,
  selectedIds: _propTypes.default.arrayOf(_propTypes.default.any).isRequired,
  undoable: _propTypes.default.bool,
  icon: _propTypes.default.element
});
(0, _defineProperty2.default)(BulkDeleteButton, "defaultProps", {
  label: 'ra.action.delete',
  undoable: true,
  icon: _react.default.createElement(_Delete.default, null)
});
var EnhancedBulkDeleteButton = (0, _compose.default)((0, _reactRedux.connect)(undefined, {
  startUndoable: _raCore.startUndoable,
  dispatchCrudDeleteMany: _raCore.crudDeleteMany
}))(BulkDeleteButton);
var _default = EnhancedBulkDeleteButton;
exports.default = _default;
module.exports = exports.default;