"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _compose = _interopRequireDefault(require("recompose/compose"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _classnames = _interopRequireDefault(require("classnames"));

var _raCore = require("ra-core");

var _Button = _interopRequireDefault(require("./Button"));

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var basePath = _ref.basePath,
      dispatchCrudDelete = _ref.dispatchCrudDelete,
      filterValues = _ref.filterValues,
      label = _ref.label,
      resource = _ref.resource,
      selectedIds = _ref.selectedIds,
      startUndoable = _ref.startUndoable,
      undoable = _ref.undoable,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["basePath", "dispatchCrudDelete", "filterValues", "label", "resource", "selectedIds", "startUndoable", "undoable"]);
  return rest;
};

var DeleteButton = function (_Component) {
  (0, _inherits2.default)(DeleteButton, _Component);

  function DeleteButton() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, DeleteButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(DeleteButton)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleDelete", function (event) {
      event.stopPropagation();
      var _this$props = _this.props,
          dispatchCrudDelete = _this$props.dispatchCrudDelete,
          startUndoable = _this$props.startUndoable,
          resource = _this$props.resource,
          record = _this$props.record,
          basePath = _this$props.basePath,
          redirect = _this$props.redirect,
          undoable = _this$props.undoable,
          onClick = _this$props.onClick;

      if (undoable) {
        startUndoable((0, _raCore.crudDelete)(resource, record.id, record, basePath, redirect));
      } else {
        dispatchCrudDelete(resource, record.id, record, basePath, redirect);
      }

      if (typeof onClick === 'function') {
        onClick();
      }
    });
    return _this;
  }

  (0, _createClass2.default)(DeleteButton, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          _this$props2$label = _this$props2.label,
          label = _this$props2$label === void 0 ? 'ra.action.delete' : _this$props2$label,
          className = _this$props2.className,
          icon = _this$props2.icon,
          onClick = _this$props2.onClick,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["label", "className", "icon", "onClick"]);
      return _react.default.createElement(_Button.default, (0, _extends2.default)({
        onClick: this.handleDelete,
        label: label,
        className: (0, _classnames.default)('ra-delete-button', className),
        key: "button"
      }, sanitizeRestProps(rest)), icon);
    }
  }]);
  return DeleteButton;
}(_react.Component);

DeleteButton.propTypes = {
  basePath: _propTypes.default.string,
  className: _propTypes.default.string,
  dispatchCrudDelete: _propTypes.default.func.isRequired,
  label: _propTypes.default.string,
  record: _propTypes.default.object,
  redirect: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func]),
  resource: _propTypes.default.string.isRequired,
  startUndoable: _propTypes.default.func,
  translate: _propTypes.default.func,
  undoable: _propTypes.default.bool,
  icon: _propTypes.default.element
};
DeleteButton.defaultProps = {
  redirect: 'list',
  undoable: true,
  icon: _react.default.createElement(_Delete.default, null)
};

var _default = (0, _compose.default)((0, _reactRedux.connect)(null, {
  startUndoable: _raCore.startUndoable,
  dispatchCrudDelete: _raCore.crudDelete
}), _raCore.translate)(DeleteButton);

exports.default = _default;
module.exports = exports.default;