"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Edit = exports.EditView = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _CardBlock = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Cards/CardBlock"));

var _classnames = _interopRequireDefault(require("classnames"));

var _raCore = require("ra-core");

var _EditActions = _interopRequireDefault(require("./EditActions"));

var _TitleForRecord = _interopRequireDefault(require("../layout/TitleForRecord"));

var _CardContentInner = _interopRequireDefault(require("../layout/CardContentInner"));

var _CardContent = _interopRequireDefault(require("../layout/CardContent"));

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var actions = _ref.actions,
      aside = _ref.aside,
      children = _ref.children,
      className = _ref.className,
      crudGetOne = _ref.crudGetOne,
      crudUpdate = _ref.crudUpdate,
      data = _ref.data,
      hasCreate = _ref.hasCreate,
      hasEdit = _ref.hasEdit,
      hasList = _ref.hasList,
      hasShow = _ref.hasShow,
      id = _ref.id,
      isLoading = _ref.isLoading,
      resetForm = _ref.resetForm,
      resource = _ref.resource,
      title = _ref.title,
      translate = _ref.translate,
      version = _ref.version,
      match = _ref.match,
      location = _ref.location,
      history = _ref.history,
      options = _ref.options,
      locale = _ref.locale,
      permissions = _ref.permissions,
      undoable = _ref.undoable,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["actions", "aside", "children", "className", "crudGetOne", "crudUpdate", "data", "hasCreate", "hasEdit", "hasList", "hasShow", "id", "isLoading", "resetForm", "resource", "title", "translate", "version", "match", "location", "history", "options", "locale", "permissions", "undoable"]);
  return rest;
};

var EditView = function EditView(_ref2) {
  var actions = _ref2.actions,
      aside = _ref2.aside,
      basePath = _ref2.basePath,
      children = _ref2.children,
      className = _ref2.className,
      defaultTitle = _ref2.defaultTitle,
      hasList = _ref2.hasList,
      hasShow = _ref2.hasShow,
      record = _ref2.record,
      redirect = _ref2.redirect,
      resource = _ref2.resource,
      save = _ref2.save,
      title = _ref2.title,
      version = _ref2.version,
      rest = (0, _objectWithoutProperties2.default)(_ref2, ["actions", "aside", "basePath", "children", "className", "defaultTitle", "hasList", "hasShow", "record", "redirect", "resource", "save", "title", "version"]);

  if (typeof actions === 'undefined' && hasShow) {
    actions = _react.default.createElement(_EditActions.default, null);
  }

  if (!children) {
    return null;
  }

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _classnames.default)('edit-page', className)
  }, sanitizeRestProps(rest)), _react.default.createElement(_TitleForRecord.default, {
    title: title,
    record: record,
    defaultTitle: defaultTitle
  }), _react.default.createElement(_CardContent.default, null, actions && _react.default.createElement(_CardContentInner.default, null, _react.default.cloneElement(actions, {
    basePath: basePath,
    data: record,
    hasShow: hasShow,
    hasList: hasList,
    resource: resource
  })), record ? _react.default.createElement(_CardContentInner.default, null, _react.default.cloneElement(children, {
    basePath: basePath,
    record: record,
    redirect: typeof children.props.redirect === 'undefined' ? redirect : children.props.redirect,
    resource: resource,
    save: save,
    version: version
  })) : _react.default.createElement(_CardBlock.default, null, "\xA0")), aside && _react.default.cloneElement(aside, {
    basePath: basePath,
    record: record,
    resource: resource,
    version: version
  }));
};

exports.EditView = EditView;
EditView.propTypes = {
  actions: _propTypes.default.element,
  aside: _propTypes.default.node,
  basePath: _propTypes.default.string,
  children: _propTypes.default.element,
  className: _propTypes.default.string,
  defaultTitle: _propTypes.default.any,
  hasList: _propTypes.default.bool,
  hasShow: _propTypes.default.bool,
  record: _propTypes.default.object,
  redirect: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  resource: _propTypes.default.string,
  save: _propTypes.default.func,
  title: _propTypes.default.any,
  version: _propTypes.default.number
};

var Edit = function Edit(props) {
  return _react.default.createElement(_raCore.EditController, props, function (controllerProps) {
    return _react.default.createElement(EditView, (0, _extends2.default)({}, props, controllerProps));
  });
};

exports.Edit = Edit;
Edit.propTypes = {
  actions: _propTypes.default.element,
  aside: _propTypes.default.node,
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  hasCreate: _propTypes.default.bool,
  hasEdit: _propTypes.default.bool,
  hasShow: _propTypes.default.bool,
  hasList: _propTypes.default.bool,
  id: _propTypes.default.any.isRequired,
  resource: _propTypes.default.string.isRequired,
  title: _propTypes.default.any
};
var _default = Edit;
exports.default = _default;