"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SimpleShowLayout = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CardContentInner = _interopRequireDefault(require("../layout/CardContentInner"));

var _Labeled = _interopRequireDefault(require("../input/Labeled"));

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var children = _ref.children,
      className = _ref.className,
      record = _ref.record,
      resource = _ref.resource,
      basePath = _ref.basePath,
      version = _ref.version,
      initialValues = _ref.initialValues,
      translate = _ref.translate,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["children", "className", "record", "resource", "basePath", "version", "initialValues", "translate"]);
  return rest;
};

var SimpleShowLayout = function SimpleShowLayout(_ref2) {
  var basePath = _ref2.basePath,
      className = _ref2.className,
      children = _ref2.children,
      record = _ref2.record,
      resource = _ref2.resource,
      version = _ref2.version,
      rest = (0, _objectWithoutProperties2.default)(_ref2, ["basePath", "className", "children", "record", "resource", "version"]);
  return _react.default.createElement(_CardContentInner.default, (0, _extends2.default)({
    className: className,
    key: version
  }, sanitizeRestProps(rest)), _react.Children.map(children, function (field) {
    return field ? _react.default.createElement("div", {
      key: field.props.source,
      className: (0, _classnames.default)("ra-field ra-field-".concat(field.props.source), field.props.className)
    }, field.props.addLabel ? _react.default.createElement(_Labeled.default, {
      record: record,
      resource: resource,
      basePath: basePath,
      label: field.props.label,
      source: field.props.source,
      disabled: false
    }, field) : typeof field.type === 'string' ? field : _react.default.cloneElement(field, {
      record: record,
      resource: resource,
      basePath: basePath
    })) : null;
  }));
};

exports.SimpleShowLayout = SimpleShowLayout;
SimpleShowLayout.propTypes = {
  basePath: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.node,
  record: _propTypes.default.object,
  resource: _propTypes.default.string,
  version: _propTypes.default.number
};
var _default = SimpleShowLayout;
exports.default = _default;