"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _SimpleForm = _interopRequireDefault(require("../form/SimpleForm"));

var _SimpleFormIterator = _interopRequireDefault(require("../form/SimpleFormIterator"));

var _ArrayInput = _interopRequireDefault(require("../input/ArrayInput"));

var _BooleanInput = _interopRequireDefault(require("../input/BooleanInput"));

var _DateInput = _interopRequireDefault(require("../input/DateInput"));

var _NumberInput = _interopRequireDefault(require("../input/NumberInput"));

var _ReferenceInput = _interopRequireDefault(require("../input/ReferenceInput"));

var _ReferenceArrayInput = _interopRequireDefault(require("../input/ReferenceArrayInput"));

var _SelectInput = _interopRequireDefault(require("../input/SelectInput"));

var _TextInput = _interopRequireDefault(require("../input/TextInput"));

var _default = {
  form: {
    component: _SimpleForm.default,
    representation: function representation(_, children) {
      return "        <SimpleForm>\n".concat(children.map(function (child) {
        return "            ".concat(child.getRepresentation());
      }).join('\n'), "\n        </SimpleForm>");
    }
  },
  array: {
    component: function component(_ref) {
      var children = _ref.children,
          props = (0, _objectWithoutProperties2.default)(_ref, ["children"]);
      return _react.default.createElement(_ArrayInput.default, props, _react.default.createElement(_SimpleFormIterator.default, null, children));
    },
    representation: function representation(props, children) {
      return "<ArrayInput source=\"".concat(props.source, "\"><SimpleFormIterator>").concat(children.map(function (child) {
        return child.getRepresentation();
      }).join('\n'), "</SimpleFormIterator></ArrayInput>");
    }
  },
  boolean: {
    component: _BooleanInput.default,
    representation: function representation(props) {
      return "<BooleanInput source=\"".concat(props.source, "\" />");
    }
  },
  date: {
    component: _DateInput.default,
    representation: function representation(props) {
      return "<DateInput source=\"".concat(props.source, "\" />");
    }
  },
  email: {
    component: _TextInput.default,
    representation: function representation(props) {
      return "<TextInput source=\"".concat(props.source, "\" />");
    }
  },
  id: {
    component: _TextInput.default,
    representation: function representation(props) {
      return "<TextInput source=\"".concat(props.source, "\" />");
    }
  },
  number: {
    component: _NumberInput.default,
    representation: function representation(props) {
      return "<NumberInput source=\"".concat(props.source, "\" />");
    }
  },
  reference: {
    component: _ReferenceInput.default,
    representation: function representation(props, children) {
      return "<ReferenceInput source=\"".concat(props.source, "\" reference=\"").concat(props.reference, "\">").concat(children.getRepresentation(), "</ReferenceInput>");
    }
  },
  referenceChild: {
    component: function component(props) {
      return _react.default.createElement(_SelectInput.default, (0, _extends2.default)({
        optionText: "id"
      }, props));
    },
    representation: function representation() {
      return '<SelectInput optionText="id" />';
    }
  },
  referenceArray: {
    component: _ReferenceArrayInput.default,
    representation: function representation(props) {
      return "<ReferenceArrayInput source=\"".concat(props.source, "\" reference=\"").concat(props.reference, "\"><TextInput source=\"id\" /></ReferenceArrayInput>");
    }
  },
  referenceArrayChild: {
    component: function component(props) {
      return _react.default.createElement(_SelectInput.default, (0, _extends2.default)({
        optionText: "id"
      }, props));
    },
    representation: function representation() {
      return '<SelectInput optionText="id" />';
    }
  },
  richText: {
    component: _TextInput.default,
    representation: function representation(props) {
      return "<TextInput source=\"".concat(props.source, "\" />");
    }
  },
  string: {
    component: _TextInput.default,
    representation: function representation(props) {
      return "<TextInput source=\"".concat(props.source, "\" />");
    }
  },
  url: {
    component: _TextInput.default,
    representation: function representation(props) {
      return "<TextInput source=\"".concat(props.source, "\" />");
    }
  }
};
exports.default = _default;
module.exports = exports.default;