"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _Datagrid = _interopRequireDefault(require("../list/Datagrid"));

var _ArrayField = _interopRequireDefault(require("../field/ArrayField"));

var _BooleanField = _interopRequireDefault(require("../field/BooleanField"));

var _DateField = _interopRequireDefault(require("../field/DateField"));

var _EmailField = _interopRequireDefault(require("../field/EmailField"));

var _NumberField = _interopRequireDefault(require("../field/NumberField"));

var _ReferenceField = _interopRequireDefault(require("../field/ReferenceField"));

var _ReferenceArrayField = _interopRequireDefault(require("../field/ReferenceArrayField"));

var _RichTextField = _interopRequireDefault(require("../field/RichTextField"));

var _SimpleShowLayout = _interopRequireDefault(require("./SimpleShowLayout"));

var _TextField = _interopRequireDefault(require("../field/TextField"));

var _UrlField = _interopRequireDefault(require("../field/UrlField"));

var _default = {
  show: {
    component: function component(props) {
      return _react.default.createElement(_SimpleShowLayout.default, props);
    },
    representation: function representation(_, children) {
      return "        <SimpleShowLayout>\n".concat(children.map(function (child) {
        return "            ".concat(child.getRepresentation());
      }).join('\n'), "\n        </SimpleShowLayout>");
    }
  },
  array: {
    component: function component(_ref) {
      var children = _ref.children,
          props = (0, _objectWithoutProperties2.default)(_ref, ["children"]);
      return _react.default.createElement(_ArrayField.default, props, _react.default.createElement(_Datagrid.default, null, children));
    },
    representation: function representation(props, children) {
      return "<ArrayField source=\"".concat(props.source, "\"><Datagrid>").concat(children.map(function (child) {
        return child.getRepresentation();
      }).join('\n'), "</Datagrid></ArrayField>");
    }
  },
  boolean: {
    component: _BooleanField.default,
    representation: function representation(props) {
      return "<BooleanField source=\"".concat(props.source, "\" />");
    }
  },
  date: {
    component: _DateField.default,
    representation: function representation(props) {
      return "<DateField source=\"".concat(props.source, "\" />");
    }
  },
  email: {
    component: _EmailField.default,
    representation: function representation(props) {
      return "<EmailField source=\"".concat(props.source, "\" />");
    }
  },
  id: {
    component: _TextField.default,
    representation: function representation(props) {
      return "<TextField source=\"".concat(props.source, "\" />");
    }
  },
  number: {
    component: _NumberField.default,
    representation: function representation(props) {
      return "<NumberField source=\"".concat(props.source, "\" />");
    }
  },
  reference: {
    component: _ReferenceField.default,
    representation: function representation(props) {
      return "<ReferenceField source=\"".concat(props.source, "\" reference=\"").concat(props.reference, "\"><TextField source=\"id\" /></ReferenceField>");
    }
  },
  referenceChild: {
    component: function component(props) {
      return _react.default.createElement(_TextField.default, (0, _extends2.default)({
        source: "id"
      }, props));
    },
    representation: function representation() {
      return '<TextField source="id" />';
    }
  },
  referenceArray: {
    component: _ReferenceArrayField.default,
    representation: function representation(props) {
      return "<ReferenceArrayField source=\"".concat(props.source, "\" reference=\"").concat(props.reference, "\"><TextField source=\"id\" /></ReferenceArrayField>");
    }
  },
  referenceArrayChild: {
    component: function component(props) {
      return _react.default.createElement(_TextField.default, (0, _extends2.default)({
        source: "id"
      }, props));
    },
    representation: function representation() {
      return '<TextField source="id" />';
    }
  },
  richText: {
    component: _RichTextField.default,
    representation: function representation(props) {
      return "<RichTextField source=\"".concat(props.source, "\" />");
    }
  },
  string: {
    component: _TextField.default,
    representation: function representation(props) {
      return "<TextField source=\"".concat(props.source, "\" />");
    }
  },
  url: {
    component: _UrlField.default,
    representation: function representation(props) {
      return "<UrlField source=\"".concat(props.source, "\" />");
    }
  }
};
exports.default = _default;
module.exports = exports.default;