"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.BooleanField = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _get = _interopRequireDefault(require("lodash/get"));

var _pure = _interopRequireDefault(require("recompose/pure"));

var _Clear = _interopRequireDefault(require("@material-ui/icons/Clear"));

var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var BooleanTypography = _styledComponents.default.div.withConfig({
  displayName: "BooleanField__BooleanTypography",
  componentId: "s0ifr8-0"
})(["color:rgba(0,0,0,0.87);font-size:0.875rem;font-weight:400;line-height:1.46429em;"]);

var BooleanField = function BooleanField(_ref) {
  var className = _ref.className,
      source = _ref.source,
      _ref$record = _ref.record,
      record = _ref$record === void 0 ? {} : _ref$record,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["className", "source", "record"]);

  if ((0, _get.default)(record, source) === false) {
    return _react.default.createElement(BooleanTypography, (0, _extends2.default)({
      className: className
    }, (0, _sanitizeRestProps.default)(rest)), _react.default.createElement(_Clear.default, null));
  }

  if ((0, _get.default)(record, source) === true) {
    return _react.default.createElement(BooleanTypography, (0, _extends2.default)({
      className: className
    }, (0, _sanitizeRestProps.default)(rest)), _react.default.createElement(_Done.default, null));
  }

  return _react.default.createElement("span", (0, _extends2.default)({
    className: className
  }, (0, _sanitizeRestProps.default)(rest)));
};

exports.BooleanField = BooleanField;
BooleanField.propTypes = {
  addLabel: _propTypes.default.bool,
  basePath: _propTypes.default.string,
  className: _propTypes.default.string,
  cellClassName: _propTypes.default.string,
  headerClassName: _propTypes.default.string,
  label: _propTypes.default.string,
  record: _propTypes.default.object,
  sortBy: _propTypes.default.string,
  source: _propTypes.default.string.isRequired
};
var PureBooleanField = (0, _pure.default)(BooleanField);
PureBooleanField.defaultProps = {
  addLabel: true
};
var _default = PureBooleanField;
exports.default = _default;