"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ReferenceArrayField = exports.ReferenceArrayFieldView = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Progress = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Progress"));

var _ProgressBar = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Progress/ProgressBar"));

var _raCore = require("ra-core");

var ReferenceArrayFieldView = function ReferenceArrayFieldView(_ref) {
  var children = _ref.children,
      className = _ref.className,
      data = _ref.data,
      ids = _ref.ids,
      loadedOnce = _ref.loadedOnce,
      reference = _ref.reference,
      referenceBasePath = _ref.referenceBasePath;

  if (loadedOnce === false) {
    return _react.default.createElement(_Progress.default, {
      className: "mt-2"
    }, _react.default.createElement(_ProgressBar.default, {
      valueNow: 100,
      striped: true,
      animated: true
    }));
  }

  return _react.default.cloneElement(children, {
    className: className,
    resource: reference,
    ids: ids,
    data: data,
    loadedOnce: loadedOnce,
    basePath: referenceBasePath,
    currentSort: {}
  });
};

exports.ReferenceArrayFieldView = ReferenceArrayFieldView;
ReferenceArrayFieldView.propTypes = {
  className: _propTypes.default.string,
  data: _propTypes.default.object,
  ids: _propTypes.default.array,
  loadedOnce: _propTypes.default.bool,
  children: _propTypes.default.element.isRequired,
  reference: _propTypes.default.string.isRequired,
  referenceBasePath: _propTypes.default.string
};

var ReferenceArrayField = function ReferenceArrayField(_ref2) {
  var children = _ref2.children,
      props = (0, _objectWithoutProperties2.default)(_ref2, ["children"]);

  if (_react.default.Children.count(children) !== 1) {
    throw new Error('<ReferenceArrayField> only accepts a single child (like <Datagrid>)');
  }

  return _react.default.createElement(_raCore.ReferenceArrayFieldController, props, function (controllerProps) {
    return _react.default.createElement(ReferenceArrayFieldView, (0, _extends2.default)({}, props, (0, _objectSpread2.default)({
      children: children
    }, controllerProps)));
  });
};

exports.ReferenceArrayField = ReferenceArrayField;
ReferenceArrayField.propTypes = {
  addLabel: _propTypes.default.bool,
  basePath: _propTypes.default.string.isRequired,
  className: _propTypes.default.string,
  children: _propTypes.default.element.isRequired,
  label: _propTypes.default.string,
  record: _propTypes.default.object.isRequired,
  reference: _propTypes.default.string.isRequired,
  resource: _propTypes.default.string.isRequired,
  sortBy: _propTypes.default.string,
  source: _propTypes.default.string.isRequired
};
var EnhancedReferenceArrayField = ReferenceArrayField;
EnhancedReferenceArrayField.defaultProps = {
  addLabel: true
};
var _default = EnhancedReferenceArrayField;
exports.default = _default;