"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _get = _interopRequireDefault(require("lodash/get"));

var _pure = _interopRequireDefault(require("recompose/pure"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var Text = _styledComponents.default.span.withConfig({
  displayName: "TextField__Text",
  componentId: "sc-1xlvqbr-0"
})(["margin:0;display:block;color:rgba(0,0,0,0.87);font-size:0.875rem;font-weight:400;line-height:1.46429em;"]);

var TextField = function TextField(_ref) {
  var className = _ref.className,
      source = _ref.source,
      _ref$record = _ref.record,
      record = _ref$record === void 0 ? {} : _ref$record,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["className", "source", "record"]);
  var value = (0, _get.default)(record, source);
  return _react.default.createElement(Text, (0, _extends2.default)({
    className: className
  }, (0, _sanitizeRestProps.default)(rest)), value && typeof value !== 'string' ? JSON.stringify(value) : value);
};

TextField.propTypes = {
  addLabel: _propTypes.default.bool,
  basePath: _propTypes.default.string,
  className: _propTypes.default.string,
  cellClassName: _propTypes.default.string,
  headerClassName: _propTypes.default.string,
  label: _propTypes.default.string,
  record: _propTypes.default.object,
  sortBy: _propTypes.default.string,
  source: _propTypes.default.string.isRequired
};
TextField.displayName = 'TextField';
var PureTextField = (0, _pure.default)(TextField);
PureTextField.defaultProps = {
  addLabel: true
};
var _default = PureTextField;
exports.default = _default;
module.exports = exports.default;