"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ArrayInput = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _raCore = require("ra-core");

var _reduxForm = require("redux-form");

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _Label = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Label"));

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var ArrayInput = function (_Component) {
  (0, _inherits2.default)(ArrayInput, _Component);

  function ArrayInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ArrayInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ArrayInput)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "renderFieldArray", function (fieldProps) {
      var _this$props = _this.props,
          children = _this$props.children,
          record = _this$props.record,
          resource = _this$props.resource,
          source = _this$props.source;
      return (0, _react.cloneElement)(children, (0, _objectSpread2.default)({}, fieldProps, {
        record: record,
        resource: resource,
        source: source
      }));
    });
    return _this;
  }

  (0, _createClass2.default)(ArrayInput, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          defaultValue = _this$props2.defaultValue,
          label = _this$props2.label,
          source = _this$props2.source,
          resource = _this$props2.resource,
          validate = _this$props2.validate,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["className", "defaultValue", "label", "source", "resource", "validate"]);
      return _react.default.createElement(_FormGroup.default, (0, _extends2.default)({
        className: className
      }, (0, _sanitizeRestProps.default)(rest)), _react.default.createElement(_Label.default, {
        htmlFor: source
      }, _react.default.createElement(_raCore.FieldTitle, {
        label: label,
        source: source,
        resource: resource,
        isRequired: (0, _raCore.isRequired)(validate)
      })), _react.default.createElement(_reduxForm.FieldArray, {
        name: source,
        defaultValue: defaultValue,
        component: this.renderFieldArray,
        validate: validate,
        isRequired: (0, _raCore.isRequired)(validate)
      }));
    }
  }]);
  return ArrayInput;
}(_react.Component);

exports.ArrayInput = ArrayInput;
ArrayInput.propTypes = {
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  defaultValue: _propTypes.default.any,
  isRequired: _propTypes.default.bool,
  label: _propTypes.default.string,
  resource: _propTypes.default.string,
  source: _propTypes.default.string,
  record: _propTypes.default.object,
  options: _propTypes.default.object,
  validate: _propTypes.default.func
};
ArrayInput.defaultProps = {
  options: {},
  fullWidth: true
};
var _default = ArrayInput;
exports.default = _default;