"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.CheckboxGroupInput = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _get = _interopRequireDefault(require("lodash/get"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _FormFeedback = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormFeedback"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _Label = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Label"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _raCore = require("ra-core");

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var setFilter = _ref.setFilter,
      setPagination = _ref.setPagination,
      setSort = _ref.setSort,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["setFilter", "setPagination", "setSort"]);
  return (0, _sanitizeRestProps.default)(rest);
};

var CheckboxGroupInput = function (_Component) {
  (0, _inherits2.default)(CheckboxGroupInput, _Component);

  function CheckboxGroupInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, CheckboxGroupInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(CheckboxGroupInput)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleCheck", function (event, isChecked) {
      var _this$props$input = _this.props.input,
          value = _this$props$input.value,
          onChange = _this$props$input.onChange;
      var newValue;

      try {
        newValue = JSON.parse(event.target.value);
      } catch (e) {
        newValue = event.target.value;
      }

      if (isChecked) {
        onChange([].concat((0, _toConsumableArray2.default)(value || []), [newValue]));
      } else {
        onChange(value.filter(function (v) {
          return v != newValue;
        }));
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "renderCheckbox", function (choice) {
      var _this$props = _this.props,
          id = _this$props.id,
          value = _this$props.input.value,
          optionText = _this$props.optionText,
          optionValue = _this$props.optionValue,
          options = _this$props.options,
          translate = _this$props.translate,
          translateChoice = _this$props.translateChoice;
      var choiceName = _react.default.isValidElement(optionText) ? _react.default.cloneElement(optionText, {
        record: choice
      }) : typeof optionText === 'function' ? optionText(choice) : (0, _get.default)(choice, optionText);
      return _react.default.createElement(_Label.default, {
        check: true,
        key: (0, _get.default)(choice, optionValue)
      }, _react.default.createElement(_Input.default, (0, _extends2.default)({
        type: "checkbox",
        id: id,
        checked: value ? value.find(function (v) {
          return v === (0, _get.default)(choice, optionValue);
        }) !== undefined : false,
        onChange: _this.handleCheck,
        value: String((0, _get.default)(choice, optionValue))
      }, options)), translateChoice ? translate(choiceName, {
        _: choiceName
      }) : choiceName);
    });
    return _this;
  }

  (0, _createClass2.default)(CheckboxGroupInput, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          choices = _this$props2.choices,
          className = _this$props2.className,
          isRequired = _this$props2.isRequired,
          label = _this$props2.label,
          meta = _this$props2.meta,
          resource = _this$props2.resource,
          source = _this$props2.source,
          input = _this$props2.input,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["choices", "className", "isRequired", "label", "meta", "resource", "source", "input"]);

      if (typeof meta === 'undefined') {
        throw new Error("The CheckboxGroupInput component wasn't called within a redux-form <Field>. Did you decorate it and forget to add the addField prop to your component? See https://marmelab.com/react-admin/Inputs.html#writing-your-own-input-component for details.");
      }

      var touched = meta.touched,
          error = meta.error,
          _meta$helperText = meta.helperText,
          helperText = _meta$helperText === void 0 ? false : _meta$helperText;
      return _react.default.createElement(_FormGroup.default, (0, _extends2.default)({
        check: true,
        className: className
      }, sanitizeRestProps(rest)), _react.default.createElement(_raCore.FieldTitle, {
        label: label,
        source: source,
        resource: resource,
        isRequired: isRequired
      }), _react.default.createElement("div", {
        className: "d-flex"
      }, choices.map(this.renderCheckbox)), touched && error && _react.default.createElement(_FormFeedback.default, null, error), helperText && _react.default.createElement(_FormFeedback.default, null, helperText));
    }
  }]);
  return CheckboxGroupInput;
}(_react.Component);

exports.CheckboxGroupInput = CheckboxGroupInput;
CheckboxGroupInput.propTypes = {
  choices: _propTypes.default.arrayOf(_propTypes.default.object),
  className: _propTypes.default.string,
  label: _propTypes.default.string,
  source: _propTypes.default.string,
  options: _propTypes.default.object,
  id: _propTypes.default.string,
  input: _propTypes.default.shape({
    onChange: _propTypes.default.func.isRequired
  }),
  isRequired: _propTypes.default.bool,
  optionText: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.element]).isRequired,
  optionValue: _propTypes.default.string.isRequired,
  resource: _propTypes.default.string,
  translate: _propTypes.default.func.isRequired,
  translateChoice: _propTypes.default.bool.isRequired,
  meta: _propTypes.default.object
};
CheckboxGroupInput.defaultProps = {
  choices: [],
  options: {},
  optionText: 'name',
  optionValue: 'id',
  translateChoice: true
};
var EnhancedCheckboxGroupInput = (0, _compose.default)(_raCore.addField, _raCore.translate)(CheckboxGroupInput);
var _default = EnhancedCheckboxGroupInput;
exports.default = _default;