"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DateInput = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _FormFeedback = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormFeedback"));

var _raCore = require("ra-core");

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var dateFormatter = function dateFormatter(v) {
  if (!(v instanceof Date) || isNaN(v)) return;
  var pad = '00';
  var yyyy = v.getFullYear().toString();
  var MM = (v.getMonth() + 1).toString();
  var dd = v.getDate().toString();
  return "".concat(yyyy, "-").concat((pad + MM).slice(-2), "-").concat((pad + dd).slice(-2));
};

var dateRegex = /^\d{4}-\d{2}-\d{2}$/;

var sanitizeValue = function sanitizeValue(value) {
  if (value == null || value === '') {
    return '';
  }

  if (dateRegex.test(value)) {
    return value;
  }

  var finalValue = (0, _typeof2.default)(value) instanceof Date ? value : new Date(value);
  return dateFormatter(finalValue);
};

var DateInput = function (_Component) {
  (0, _inherits2.default)(DateInput, _Component);

  function DateInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, DateInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(DateInput)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onChange", function (event) {
      _this.props.input.onChange(event.target.value);
    });
    return _this;
  }

  (0, _createClass2.default)(DateInput, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          meta = _this$props.meta,
          input = _this$props.input,
          isRequired = _this$props.isRequired,
          label = _this$props.label,
          options = _this$props.options,
          source = _this$props.source,
          resource = _this$props.resource,
          helperText = _this$props.helperText,
          rest = (0, _objectWithoutProperties2.default)(_this$props, ["className", "meta", "input", "isRequired", "label", "options", "source", "resource", "helperText"]);

      if (typeof meta === 'undefined') {
        throw new Error("The DateInput component wasn't called within a redux-form <Field>. Did you decorate it and forget to add the addField prop to your component? See https://marmelab.com/react-admin/Inputs.html#writing-your-own-input-component for details.");
      }

      var touched = meta.touched,
          error = meta.error;
      var value = sanitizeValue(input.value);
      return _react.default.createElement(_FormGroup.default, (0, _extends2.default)({
        color: error ? 'danger' : '',
        className: className
      }, (0, _sanitizeRestProps.default)(rest)), _react.default.createElement(_raCore.FieldTitle, {
        label: label,
        source: source,
        resource: resource,
        isRequired: isRequired
      }), _react.default.createElement(_Input.default, (0, _extends2.default)({
        type: "date",
        onChange: this.onChange,
        value: value
      }, input, options)), !!(touched && error) && _react.default.createElement(_FormFeedback.default, null, error));
    }
  }]);
  return DateInput;
}(_react.Component);

exports.DateInput = DateInput;
DateInput.propTypes = {
  className: _propTypes.default.string,
  input: _propTypes.default.object,
  isRequired: _propTypes.default.bool,
  label: _propTypes.default.string,
  meta: _propTypes.default.object,
  options: _propTypes.default.object,
  resource: _propTypes.default.string,
  source: _propTypes.default.string
};
DateInput.defaultProps = {
  options: {}
};

var _default = (0, _raCore.addField)(DateInput);

exports.default = _default;