"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _raCore = require("ra-core");

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var DisabledInput = function DisabledInput(_ref) {
  var className = _ref.className,
      record = _ref.record,
      value = _ref.input.value,
      label = _ref.label,
      resource = _ref.resource,
      source = _ref.source,
      options = _ref.options,
      labelHidden = _ref.labelHidden,
      classNameInput = _ref.classNameInput,
      input = _ref.input,
      size = _ref.size,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["className", "record", "input", "label", "resource", "source", "options", "labelHidden", "classNameInput", "input", "size"]);
  return _react.default.createElement(_FormGroup.default, (0, _extends2.default)({
    className: className
  }, (0, _sanitizeRestProps.default)(rest)), _react.default.createElement(_raCore.FieldTitle, {
    label: label,
    source: source,
    resource: resource
  }), _react.default.createElement(_Input.default, {
    size: size,
    className: classNameInput,
    value: value,
    disabled: true
  }));
};

DisabledInput.propTypes = {
  className: _propTypes.default.string,
  label: _propTypes.default.string,
  input: _propTypes.default.object,
  record: _propTypes.default.object,
  resource: _propTypes.default.string,
  source: _propTypes.default.string,
  labelHidden: _propTypes.default.bool,
  classNameInput: _propTypes.default.string,
  size: _propTypes.default.string
};

var _default = (0, _raCore.addField)(DisabledInput);

exports.default = _default;
module.exports = exports.default;