"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.LongTextInput = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _raCore = require("ra-core");

var _ResettableTextField = _interopRequireDefault(require("./ResettableTextField"));

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var LongTextInput = function LongTextInput(_ref) {
  var className = _ref.className,
      input = _ref.input,
      meta = _ref.meta,
      isRequired = _ref.isRequired,
      label = _ref.label,
      options = _ref.options,
      source = _ref.source,
      resource = _ref.resource,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["className", "input", "meta", "isRequired", "label", "options", "source", "resource"]);

  if (typeof meta === 'undefined') {
    throw new Error("The LongTextInput component wasn't called within a redux-form <Field>. Did you decorate it and forget to add the addField prop to your component? See https://marmelab.com/react-admin/Inputs.html#writing-your-own-input-component for details.");
  }

  var touched = meta.touched,
      error = meta.error;
  return _react.default.createElement(_ResettableTextField.default, (0, _extends2.default)({}, input, {
    className: className,
    type: "textarea",
    label: _react.default.createElement(_raCore.FieldTitle, {
      label: label,
      source: source,
      resource: resource,
      isRequired: isRequired
    }),
    error: !!(touched && error),
    helperText: touched && error
  }, (0, _sanitizeRestProps.default)(rest), options));
};

exports.LongTextInput = LongTextInput;
LongTextInput.propTypes = {
  className: _propTypes.default.string,
  input: _propTypes.default.object,
  isRequired: _propTypes.default.bool,
  label: _propTypes.default.string,
  meta: _propTypes.default.object,
  name: _propTypes.default.string,
  options: _propTypes.default.object,
  resource: _propTypes.default.string,
  source: _propTypes.default.string,
  validate: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.arrayOf(_propTypes.default.func)])
};
var EnhancedLongTextInput = (0, _raCore.addField)(LongTextInput);
EnhancedLongTextInput.defaultProps = {
  options: {}
};
var _default = EnhancedLongTextInput;
exports.default = _default;