"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.NullableBooleanInput = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _Option = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Option"));

var _FormFeedback = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormFeedback"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _raCore = require("ra-core");

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var NullableBooleanInput = function (_Component) {
  (0, _inherits2.default)(NullableBooleanInput, _Component);

  function NullableBooleanInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, NullableBooleanInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(NullableBooleanInput)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      value: _this.props.input.value
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleChange", function (event) {
      _this.props.input.onChange(_this.getBooleanFromString(event.target.value));

      _this.setState({
        value: event.target.value
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "getBooleanFromString", function (value) {
      if (value === 'true') return true;
      if (value === 'false') return false;
      return null;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "getStringFromBoolean", function (value) {
      if (value === true) return 'true';
      if (value === false) return 'false';
      return '';
    });
    return _this;
  }

  (0, _createClass2.default)(NullableBooleanInput, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value !== this.props.input.value) {
        this.setState({
          value: nextProps.input.value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          isRequired = _this$props.isRequired,
          label = _this$props.label,
          meta = _this$props.meta,
          options = _this$props.options,
          resource = _this$props.resource,
          source = _this$props.source,
          translate = _this$props.translate,
          rest = (0, _objectWithoutProperties2.default)(_this$props, ["className", "isRequired", "label", "meta", "options", "resource", "source", "translate"]);
      var touched = meta.touched,
          error = meta.error;
      return _react.default.createElement(_FormGroup.default, {
        color: error ? 'danger' : '',
        className: className
      }, _react.default.createElement(_raCore.FieldTitle, {
        label: label,
        source: source,
        resource: resource,
        isRequired: isRequired
      }), _react.default.createElement(_Input.default, (0, _extends2.default)({
        value: this.getStringFromBoolean(this.state.value),
        onChange: this.handleChange,
        type: "select"
      }, options, (0, _sanitizeRestProps.default)(rest)), _react.default.createElement(_Option.default, {
        value: ""
      }), _react.default.createElement(_Option.default, {
        value: "false"
      }, translate('ra.boolean.false')), _react.default.createElement(_Option.default, {
        value: "true"
      }, translate('ra.boolean.true'))), !!(touched && error) && _react.default.createElement(_FormFeedback.default, null, error));
    }
  }]);
  return NullableBooleanInput;
}(_react.Component);

exports.NullableBooleanInput = NullableBooleanInput;
NullableBooleanInput.propTypes = {
  className: _propTypes.default.string,
  input: _propTypes.default.object,
  isRequired: _propTypes.default.bool,
  label: _propTypes.default.string,
  meta: _propTypes.default.object,
  options: _propTypes.default.object,
  resource: _propTypes.default.string,
  source: _propTypes.default.string,
  translate: _propTypes.default.func.isRequired
};
var enhance = (0, _compose.default)(_raCore.addField, _raCore.translate);

var _default = enhance(NullableBooleanInput);

exports.default = _default;