"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.NumberInputWithField = exports.NumberInput = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _FormFeedback = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormFeedback"));

var _raCore = require("ra-core");

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var NumberInput = function (_Component) {
  (0, _inherits2.default)(NumberInput, _Component);

  function NumberInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, NumberInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(NumberInput)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleBlur", function (event) {
      var numericValue = isNaN(parseFloat(event.target.value)) ? null : parseFloat(event.target.value);

      _this.props.onBlur(numericValue);

      _this.props.input.onBlur(numericValue);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleFocus", function (event) {
      _this.props.onFocus(event);

      _this.props.input.onFocus(event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleChange", function (event) {
      var numericValue = isNaN(parseFloat(event.target.value)) ? null : parseFloat(event.target.value);

      _this.props.onChange(numericValue);

      _this.props.input.onChange(numericValue);
    });
    return _this;
  }

  (0, _createClass2.default)(NumberInput, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          input = _this$props.input,
          isRequired = _this$props.isRequired,
          label = _this$props.label,
          meta = _this$props.meta,
          options = _this$props.options,
          source = _this$props.source,
          step = _this$props.step,
          resource = _this$props.resource,
          rest = (0, _objectWithoutProperties2.default)(_this$props, ["className", "input", "isRequired", "label", "meta", "options", "source", "step", "resource"]);

      if (typeof meta === 'undefined') {
        throw new Error("The NumberInput component wasn't called within a redux-form <Field>. Did you decorate it and forget to add the addField prop to your component? See https://marmelab.com/react-admin/Inputs.html#writing-your-own-input-component for details.");
      }

      var touched = meta.touched,
          error = meta.error;
      return _react.default.createElement(_FormGroup.default, (0, _extends2.default)({
        color: error ? 'danger' : '',
        className: className
      }, (0, _sanitizeRestProps.default)(rest)), _react.default.createElement(_raCore.FieldTitle, {
        label: label,
        source: source,
        resource: resource,
        isRequired: isRequired
      }), _react.default.createElement(_Input.default, (0, _extends2.default)({
        type: "number"
      }, input, options, {
        step: step,
        onBlur: this.handleBlur,
        onFocus: this.handleFocus,
        onChange: this.handleChange
      })), !!(touched && error) && _react.default.createElement(_FormFeedback.default, null, error));
    }
  }]);
  return NumberInput;
}(_react.Component);

exports.NumberInput = NumberInput;
NumberInput.propTypes = {
  className: _propTypes.default.string,
  input: _propTypes.default.object,
  isRequired: _propTypes.default.bool,
  label: _propTypes.default.string,
  meta: _propTypes.default.object,
  name: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  options: _propTypes.default.object,
  resource: _propTypes.default.string,
  source: _propTypes.default.string,
  step: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]).isRequired,
  validate: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.arrayOf(_propTypes.default.func)])
};
NumberInput.defaultProps = {
  onBlur: function onBlur() {},
  onChange: function onChange() {},
  onFocus: function onFocus() {},
  options: {},
  step: 'any',
  textAlign: 'right'
};
var NumberInputWithField = (0, _raCore.addField)(NumberInput);
exports.NumberInputWithField = NumberInputWithField;
NumberInputWithField.defaultProps = {
  textAlign: 'right'
};
var _default = NumberInputWithField;
exports.default = _default;