"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.RadioButtonGroupInput = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _get = _interopRequireDefault(require("lodash/get"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _FormFeedback = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormFeedback"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _Label = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Label"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _raCore = require("ra-core");

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var RadioButtonGroupInput = function (_Component) {
  (0, _inherits2.default)(RadioButtonGroupInput, _Component);

  function RadioButtonGroupInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, RadioButtonGroupInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(RadioButtonGroupInput)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleChange", function (event, value) {
      _this.props.input.onChange(value);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "renderRadioButton", function (choice) {
      var _this$props = _this.props,
          id = _this$props.id,
          optionText = _this$props.optionText,
          optionValue = _this$props.optionValue,
          translate = _this$props.translate,
          translateChoice = _this$props.translateChoice,
          resource = _this$props.resource,
          input = _this$props.input;
      var choiceName = _react.default.isValidElement(optionText) ? _react.default.cloneElement(optionText, {
        record: choice
      }) : typeof optionText === 'function' ? optionText(choice) : (0, _get.default)(choice, optionText);
      return _react.default.createElement(_Label.default, {
        check: true,
        checked: choice == input.value,
        key: (0, _get.default)(choice, optionValue),
        htmlFor: "".concat(id, "_").concat((0, _get.default)(choice, optionValue))
      }, _react.default.createElement(_Input.default, {
        value: (0, _get.default)(choice, optionValue),
        name: resource,
        onChange: _this.handleChange,
        type: "radio"
      }), translateChoice ? translate(choiceName, {
        _: choiceName
      }) : choiceName);
    });
    return _this;
  }

  (0, _createClass2.default)(RadioButtonGroupInput, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          label = _this$props2.label,
          resource = _this$props2.resource,
          source = _this$props2.source,
          input = _this$props2.input,
          isRequired = _this$props2.isRequired,
          choices = _this$props2.choices,
          options = _this$props2.options,
          meta = _this$props2.meta,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["className", "label", "resource", "source", "input", "isRequired", "choices", "options", "meta"]);

      if (typeof meta === 'undefined') {
        throw new Error("The RadioButtonGroupInput component wasn't called within a redux-form <Field>. Did you decorate it and forget to add the addField prop to your component? See https://marmelab.com/react-admin/Inputs.html#writing-your-own-input-component for details.");
      }

      var touched = meta.touched,
          error = meta.error,
          _meta$helperText = meta.helperText,
          helperText = _meta$helperText === void 0 ? false : _meta$helperText;
      return _react.default.createElement(_FormGroup.default, (0, _extends2.default)({
        check: true,
        className: className
      }, (0, _sanitizeRestProps.default)(rest)), _react.default.createElement(_raCore.FieldTitle, {
        label: label,
        source: source,
        resource: resource,
        isRequired: isRequired
      }), choices.map(this.renderRadioButton), !!(touched && error) && _react.default.createElement(_FormFeedback.default, null, error), helperText && _react.default.createElement(_FormFeedback.default, null, helperText));
    }
  }]);
  return RadioButtonGroupInput;
}(_react.Component);

exports.RadioButtonGroupInput = RadioButtonGroupInput;
RadioButtonGroupInput.propTypes = {
  choices: _propTypes.default.arrayOf(_propTypes.default.object),
  className: _propTypes.default.string,
  id: _propTypes.default.string,
  input: _propTypes.default.object,
  isRequired: _propTypes.default.bool,
  label: _propTypes.default.string,
  options: _propTypes.default.object,
  optionText: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.element]).isRequired,
  optionValue: _propTypes.default.string.isRequired,
  resource: _propTypes.default.string,
  source: _propTypes.default.string,
  translate: _propTypes.default.func.isRequired,
  translateChoice: _propTypes.default.bool.isRequired,
  meta: _propTypes.default.object
};
RadioButtonGroupInput.defaultProps = {
  choices: [],
  options: {},
  optionText: 'name',
  optionValue: 'id',
  translateChoice: true
};

var _default = (0, _compose.default)(_raCore.addField, _raCore.translate)(RadioButtonGroupInput);

exports.default = _default;