"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _FormFeedback = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormFeedback"));

var _InputAdornment = _interopRequireDefault(require("@material-ui/core/InputAdornment"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Clear = _interopRequireDefault(require("@material-ui/icons/Clear"));

var _raCore = require("ra-core");

var ResettableTextField = function (_Component) {
  (0, _inherits2.default)(ResettableTextField, _Component);

  function ResettableTextField() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ResettableTextField);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ResettableTextField)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleClickClearButton", function (event) {
      event.preventDefault();

      _this.props.onChange('');
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleMouseDownClearButton", function (event) {
      event.preventDefault();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleFocus", function (event) {
      _this.props.onFocus && _this.props.onFocus(event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleBlur", function (event) {
      _this.props.onBlur && _this.props.onBlur(event);
    });
    return _this;
  }

  (0, _createClass2.default)(ResettableTextField, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          translate = _this$props.translate,
          clearAlwaysVisible = _this$props.clearAlwaysVisible,
          InputProps = _this$props.InputProps,
          value = _this$props.value,
          error = _this$props.error,
          helperText = _this$props.helperText,
          className = _this$props.className,
          label = _this$props.label,
          fullWidth = _this$props.fullWidth,
          resettable = _this$props.resettable,
          props = (0, _objectWithoutProperties2.default)(_this$props, ["translate", "clearAlwaysVisible", "InputProps", "value", "error", "helperText", "className", "label", "fullWidth", "resettable"]);
      return _react.default.createElement(_FormGroup.default, {
        color: error ? 'danger' : '',
        className: className
      }, label, _react.default.createElement(_Input.default, (0, _extends2.default)({
        onBlur: this.handleBlur,
        onFocus: this.handleFocus,
        value: value,
        className: (0, _classnames.default)({
          'w-100': fullWidth
        })
      }, InputProps, props)), InputProps && !InputProps.endAdornment ? resettable && value && _react.default.createElement(_InputAdornment.default, {
        position: "end"
      }, _react.default.createElement(_IconButton.default, {
        "aria-label": translate('ra.action.clear_input_value'),
        title: translate('ra.action.clear_input_value'),
        disableRipple: true,
        onClick: this.handleClickClearButton,
        onMouseDown: this.handleMouseDownClearButton
      }, _react.default.createElement(_Clear.default, null))) : InputProps && InputProps.endAdornment, error && _react.default.createElement(_FormFeedback.default, null, helperText));
    }
  }]);
  return ResettableTextField;
}(_react.Component);

(0, _defineProperty2.default)(ResettableTextField, "propTypes", {
  clearAlwaysVisible: _propTypes.default.bool,
  InputProps: _propTypes.default.object,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func.isRequired,
  onFocus: _propTypes.default.func,
  resettable: _propTypes.default.bool,
  translate: _propTypes.default.func.isRequired,
  value: _propTypes.default.any.isRequired
});

var _default = (0, _compose.default)(_raCore.translate)(ResettableTextField);

exports.default = _default;
module.exports = exports.default;