"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TextInput = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _raCore = require("ra-core");

var _ResettableTextField = _interopRequireDefault(require("./ResettableTextField"));

var _sanitizeRestProps = _interopRequireDefault(require("./sanitizeRestProps"));

var TextInput = function (_Component) {
  (0, _inherits2.default)(TextInput, _Component);

  function TextInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, TextInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(TextInput)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleBlur", function (eventOrValue) {
      _this.props.onBlur(eventOrValue);

      _this.props.input.onBlur(eventOrValue);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleFocus", function (event) {
      _this.props.onFocus(event);

      _this.props.input.onFocus(event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleChange", function (eventOrValue) {
      _this.props.onChange(eventOrValue);

      _this.props.input.onChange(eventOrValue);
    });
    return _this;
  }

  (0, _createClass2.default)(TextInput, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          input = _this$props.input,
          isRequired = _this$props.isRequired,
          label = _this$props.label,
          meta = _this$props.meta,
          options = _this$props.options,
          resource = _this$props.resource,
          source = _this$props.source,
          type = _this$props.type,
          rest = (0, _objectWithoutProperties2.default)(_this$props, ["className", "input", "isRequired", "label", "meta", "options", "resource", "source", "type"]);

      if (typeof meta === 'undefined') {
        throw new Error("The TextInput component wasn't called within a redux-form <Field>. Did you decorate it and forget to add the addField prop to your component? See https://marmelab.com/react-admin/Inputs.html#writing-your-own-input-component for details.");
      }

      var touched = meta.touched,
          error = meta.error;
      return _react.default.createElement(_ResettableTextField.default, (0, _extends2.default)({
        margin: "normal",
        type: type,
        label: label === false ? label : _react.default.createElement(_raCore.FieldTitle, {
          label: label,
          source: source,
          resource: resource,
          isRequired: isRequired
        }),
        error: !!(touched && error),
        helperText: touched && error,
        className: className
      }, options, (0, _sanitizeRestProps.default)(rest), input, {
        onBlur: this.handleBlur,
        onFocus: this.handleFocus,
        onChange: this.handleChange
      }));
    }
  }]);
  return TextInput;
}(_react.Component);

exports.TextInput = TextInput;
TextInput.propTypes = {
  className: _propTypes.default.string,
  input: _propTypes.default.object,
  isRequired: _propTypes.default.bool,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  meta: _propTypes.default.object,
  name: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  options: _propTypes.default.object,
  resource: _propTypes.default.string,
  source: _propTypes.default.string,
  type: _propTypes.default.string
};
TextInput.defaultProps = {
  onBlur: function onBlur() {},
  onChange: function onChange() {},
  onFocus: function onFocus() {},
  options: {},
  type: 'text'
};

var _default = (0, _raCore.addField)(TextInput);

exports.default = _default;