"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Dialog = _interopRequireDefault(require("@material-ui/core/Dialog"));

var _DialogActions = _interopRequireDefault(require("@material-ui/core/DialogActions"));

var _DialogContent = _interopRequireDefault(require("@material-ui/core/DialogContent"));

var _DialogContentText = _interopRequireDefault(require("@material-ui/core/DialogContentText"));

var _DialogTitle = _interopRequireDefault(require("@material-ui/core/DialogTitle"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _CheckCircle = _interopRequireDefault(require("@material-ui/icons/CheckCircle"));

var _ErrorOutline = _interopRequireDefault(require("@material-ui/icons/ErrorOutline"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _raCore = require("ra-core");

var Confirm = function Confirm(_ref) {
  var isOpen = _ref.isOpen,
      title = _ref.title,
      content = _ref.content,
      confirm = _ref.confirm,
      cancel = _ref.cancel,
      confirmColor = _ref.confirmColor,
      onConfirm = _ref.onConfirm,
      onClose = _ref.onClose,
      translate = _ref.translate;
  return _react.default.createElement(_Dialog.default, {
    open: isOpen,
    onClose: onClose,
    "aria-labelledby": "alert-dialog-title"
  }, _react.default.createElement(_DialogTitle.default, {
    id: "alert-dialog-title"
  }, translate(title, {
    _: title
  })), _react.default.createElement(_DialogContent.default, null, _react.default.createElement(_DialogContentText.default, null, translate(content, {
    _: content
  }))), _react.default.createElement(_DialogActions.default, null, _react.default.createElement(_Button.default, {
    onClick: onClose
  }, _react.default.createElement(_ErrorOutline.default, null), translate(cancel, {
    _: cancel
  })), _react.default.createElement(_Button.default, {
    onClick: onConfirm,
    color: confirmColor,
    autoFocus: true
  }, _react.default.createElement(_CheckCircle.default, null), translate(confirm, {
    _: confirm
  }))));
};

Confirm.propTypes = {
  cancel: _propTypes.default.string.isRequired,
  confirm: _propTypes.default.string.isRequired,
  confirmColor: _propTypes.default.string.isRequired,
  content: _propTypes.default.string.isRequired,
  isOpen: _propTypes.default.bool,
  onClose: _propTypes.default.func.isRequired,
  onConfirm: _propTypes.default.func.isRequired,
  title: _propTypes.default.string.isRequired,
  translate: _propTypes.default.func.isRequired
};
Confirm.defaultProps = {
  cancel: 'ra.action.cancel',
  confirm: 'ra.action.confirm',
  confirmColor: 'primary',
  isOpen: false
};

var _default = (0, _compose.default)(_raCore.translate)(Confirm);

exports.default = _default;
module.exports = exports.default;