"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _Button = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Button"));

var _ExpansionPanel = _interopRequireDefault(require("@material-ui/core/ExpansionPanel"));

var _ExpansionPanelDetails = _interopRequireDefault(require("@material-ui/core/ExpansionPanelDetails"));

var _ExpansionPanelSummary = _interopRequireDefault(require("@material-ui/core/ExpansionPanelSummary"));

var _Report = _interopRequireDefault(require("@material-ui/icons/Report"));

var _ExpandMore = _interopRequireDefault(require("@material-ui/icons/ExpandMore"));

var _raCore = require("ra-core");

var _Title = _interopRequireDefault(require("./Title"));

function goBack() {
  history.go(-1);
}

var Error = function Error(_ref) {
  var error = _ref.error,
      errorInfo = _ref.errorInfo,
      className = _ref.className,
      title = _ref.title,
      translate = _ref.translate,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["error", "errorInfo", "className", "title", "translate"]);
  return _react.default.createElement(_react.Fragment, null, _react.default.createElement(_Title.default, {
    defaultTitle: title
  }), _react.default.createElement("div", (0, _extends2.default)({
    className: className
  }, rest), _react.default.createElement("h1", {
    role: "alert"
  }, _react.default.createElement(_Report.default, null), translate('ra.page.error')), _react.default.createElement("div", null, translate('ra.message.error')), process.env.NODE_ENV !== 'production' && _react.default.createElement(_ExpansionPanel.default, null, _react.default.createElement(_ExpansionPanelSummary.default, {
    expandIcon: _react.default.createElement(_ExpandMore.default, null)
  }, translate('ra.message.details')), _react.default.createElement(_ExpansionPanelDetails.default, null, _react.default.createElement("div", null, _react.default.createElement("h2", null, translate(error.toString())), errorInfo.componentStack))), _react.default.createElement("div", null, _react.default.createElement(_Button.default, {
    onClick: goBack
  }, translate('ra.action.back')))));
};

Error.propTypes = {
  className: _propTypes.default.string,
  error: _propTypes.default.object.isRequired,
  errorInfo: _propTypes.default.object,
  translate: _propTypes.default.func.isRequired,
  title: _propTypes.default.string
};
var enhance = (0, _compose.default)(_raCore.translate);

var _default = enhance(Error);

exports.default = _default;
module.exports = exports.default;