"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Header = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ViewTitle = _interopRequireDefault(require("./ViewTitle"));

var Header = function Header(_ref) {
  var className = _ref.className,
      title = _ref.title,
      actions = _ref.actions,
      actionProps = _ref.actionProps,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["className", "title", "actions", "actionProps"]);

  if (process.env.NODE_ENV !== 'production') {
    console.warn('<Header> is deprecated, please use <Title> directly instead');
  }

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _classnames.default)(className, 'd-flex justify-content-between')
  }, rest), _react.default.createElement(_ViewTitle.default, {
    title: title
  }), actions && _react.default.cloneElement(actions, actionProps));
};

exports.Header = Header;
Header.propTypes = {
  className: _propTypes.default.string,
  title: _propTypes.default.any,
  actions: _propTypes.default.element,
  actionProps: _propTypes.default.object
};
var _default = Header;
exports.default = _default;