"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _raCore = require("ra-core");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _faCircleNotch = require("@fortawesome/free-solid-svg-icons/faCircleNotch");

var Loading = function Loading(_ref) {
  var className = _ref.className,
      translate = _ref.translate,
      _ref$loadingPrimary = _ref.loadingPrimary,
      loadingPrimary = _ref$loadingPrimary === void 0 ? 'ra.page.loading' : _ref$loadingPrimary,
      _ref$loadingSecondary = _ref.loadingSecondary,
      loadingSecondary = _ref$loadingSecondary === void 0 ? 'ra.message.loading' : _ref$loadingSecondary;
  return _react.default.createElement("div", {
    className: className
  }, _react.default.createElement("div", null, _react.default.createElement(_reactFontawesome.FontAwesomeIcon, {
    className: "m-3",
    size: "2x",
    icon: _faCircleNotch.faCircleNotch,
    spin: true
  }), _react.default.createElement("h1", null, translate(loadingPrimary)), _react.default.createElement("div", null, translate(loadingSecondary), ".")));
};

Loading.propTypes = {
  className: _propTypes.default.string,
  translate: _propTypes.default.func.isRequired,
  loadingPrimary: _propTypes.default.string,
  loadingSecondary: _propTypes.default.string
};
Loading.defaultProps = {
  loadingPrimary: 'ra.page.loading',
  loadingSecondary: 'ra.message.loading'
};
var enhance = (0, _compose.default)(_raCore.translate);

var _default = enhance(Loading);

exports.default = _default;
module.exports = exports.default;