"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.LoadingIndicator = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _compose = _interopRequireDefault(require("recompose/compose"));

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

var _RefreshIconButton = _interopRequireDefault(require("../button/RefreshIconButton"));

var LoadingIndicator = function LoadingIndicator(_ref) {
  var className = _ref.className,
      isLoading = _ref.isLoading,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["className", "isLoading"]);
  return isLoading ? _react.default.createElement(_CircularProgress.default, (0, _extends2.default)({
    size: 25,
    thickness: 2
  }, rest)) : _react.default.createElement(_RefreshIconButton.default, null);
};

exports.LoadingIndicator = LoadingIndicator;
LoadingIndicator.propTypes = {
  className: _propTypes.default.string,
  isLoading: _propTypes.default.bool,
  width: _propTypes.default.string
};

var mapStateToProps = function mapStateToProps(state) {
  return {
    isLoading: state.admin.loading > 0
  };
};

var _default = (0, _compose.default)((0, _reactRedux.connect)(mapStateToProps, {}))(LoadingIndicator);

exports.default = _default;