"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _raCore = require("ra-core");

var _CardActions = _interopRequireDefault(require("../layout/CardActions"));

var BulkActionsToolbar = function BulkActionsToolbar(_ref) {
  var basePath = _ref.basePath,
      filterValues = _ref.filterValues,
      label = _ref.label,
      resource = _ref.resource,
      selectedIds = _ref.selectedIds,
      translate = _ref.translate,
      children = _ref.children,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["basePath", "filterValues", "label", "resource", "selectedIds", "translate", "children"]);
  return selectedIds.length > 0 ? _react.default.createElement(_Toolbar.default, (0, _extends2.default)({
    "data-test": "bulk-actions-toolbar"
  }, (0, _raCore.sanitizeListRestProps)(rest)), _react.default.createElement("div", null, _react.default.createElement("h2", null, translate(label, {
    _: label,
    smart_count: selectedIds.length
  }))), _react.default.createElement(_CardActions.default, null, _react.Children.map(children, function (child) {
    return (0, _react.cloneElement)(child, {
      basePath: basePath,
      filterValues: filterValues,
      resource: resource,
      selectedIds: selectedIds
    });
  }))) : _react.default.createElement(_Toolbar.default, null);
};

BulkActionsToolbar.propTypes = {
  children: _propTypes.default.node,
  basePath: _propTypes.default.string,
  filterValues: _propTypes.default.object,
  label: _propTypes.default.string,
  resource: _propTypes.default.string,
  selectedIds: _propTypes.default.array,
  translate: _propTypes.default.func.isRequired
};
BulkActionsToolbar.defaultProps = {
  label: 'ra.action.bulk_actions'
};
var enhance = (0, _compose.default)(_raCore.translate);

var _default = enhance(BulkActionsToolbar);

exports.default = _default;
module.exports = exports.default;