"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _raCore = require("ra-core");

var _Table = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table"));

var _Thead = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Thead"));

var _Tr = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Tr"));

var _Th = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Th"));

var _FormCustom = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormCustom"));

var _DatagridHeaderCell = _interopRequireDefault(require("./DatagridHeaderCell"));

var _DatagridBody = _interopRequireDefault(require("./DatagridBody"));

var _DatagridLoading = _interopRequireDefault(require("./DatagridLoading"));

var Datagrid = function (_Component) {
  (0, _inherits2.default)(Datagrid, _Component);

  function Datagrid() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, Datagrid);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Datagrid)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "updateSort", function (event) {
      event.stopPropagation();

      _this.props.setSort(event.currentTarget.dataset.sort);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleSelectAll", function (event) {
      var _this$props = _this.props,
          onSelect = _this$props.onSelect,
          ids = _this$props.ids,
          selectedIds = _this$props.selectedIds;

      if (event.target.checked) {
        onSelect(ids.reduce(function (idList, id) {
          return idList.indexOf(id) !== -1 ? idList : idList.concat(id);
        }, selectedIds));
      } else {
        onSelect([]);
      }
    });
    return _this;
  }

  (0, _createClass2.default)(Datagrid, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          basePath = _this$props2.basePath,
          body = _this$props2.body,
          children = _this$props2.children,
          className = _this$props2.className,
          currentSort = _this$props2.currentSort,
          data = _this$props2.data,
          expand = _this$props2.expand,
          hasBulkActions = _this$props2.hasBulkActions,
          ids = _this$props2.ids,
          isLoading = _this$props2.isLoading,
          loadedOnce = _this$props2.loadedOnce,
          onSelect = _this$props2.onSelect,
          onToggleItem = _this$props2.onToggleItem,
          resource = _this$props2.resource,
          rowClick = _this$props2.rowClick,
          rowStyle = _this$props2.rowStyle,
          selectedIds = _this$props2.selectedIds,
          setSort = _this$props2.setSort,
          total = _this$props2.total,
          version = _this$props2.version,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["basePath", "body", "children", "className", "currentSort", "data", "expand", "hasBulkActions", "ids", "isLoading", "loadedOnce", "onSelect", "onToggleItem", "resource", "rowClick", "rowStyle", "selectedIds", "setSort", "total", "version"]);

      if (loadedOnce === false) {
        return _react.default.createElement(_DatagridLoading.default, {
          className: className,
          expand: expand,
          hasBulkActions: hasBulkActions,
          nbChildren: _react.default.Children.count(children)
        });
      }

      if (!isLoading && (ids.length === 0 || total === 0)) {
        return null;
      }

      return _react.default.createElement(_Table.default, (0, _extends2.default)({
        hover: true,
        className: className,
        style: {
          tableLayout: 'auto'
        }
      }, (0, _raCore.sanitizeListRestProps)(rest)), _react.default.createElement(_Thead.default, null, _react.default.createElement(_Tr.default, null, expand && _react.default.createElement(_Th.default, null), hasBulkActions && _react.default.createElement(_Th.default, null, _react.default.createElement(_FormCustom.default, {
        className: "select-all cursor-pointer mb-0",
        checked: selectedIds.length > 0 && ids.length > 0 && !ids.find(function (it) {
          return selectedIds.indexOf(it) === -1;
        }),
        onChange: this.handleSelectAll
      })), _react.default.Children.map(children, function (field, index) {
        return field ? _react.default.createElement(_DatagridHeaderCell.default, {
          currentSort: currentSort,
          field: field,
          isSorting: currentSort.field === (field.props.sortBy || field.props.source),
          key: field.props.source || index,
          resource: resource,
          updateSort: _this2.updateSort
        }) : null;
      }))), _react.default.cloneElement(body, {
        basePath: basePath,
        expand: expand,
        rowClick: rowClick,
        data: data,
        hasBulkActions: hasBulkActions,
        ids: ids,
        isLoading: isLoading,
        onToggleItem: onToggleItem,
        resource: resource,
        rowStyle: rowStyle,
        selectedIds: selectedIds,
        version: version
      }, children));
    }
  }]);
  return Datagrid;
}(_react.Component);

Datagrid.propTypes = {
  basePath: _propTypes.default.string,
  body: _propTypes.default.element.isRequired,
  children: _propTypes.default.node.isRequired,
  className: _propTypes.default.string,
  currentSort: _propTypes.default.shape({
    field: _propTypes.default.string,
    order: _propTypes.default.string
  }),
  data: _propTypes.default.object.isRequired,
  expand: _propTypes.default.node,
  hasBulkActions: _propTypes.default.bool.isRequired,
  ids: _propTypes.default.arrayOf(_propTypes.default.any).isRequired,
  isLoading: _propTypes.default.bool,
  onSelect: _propTypes.default.func,
  onToggleItem: _propTypes.default.func,
  resource: _propTypes.default.string,
  rowClick: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  rowStyle: _propTypes.default.func,
  selectedIds: _propTypes.default.arrayOf(_propTypes.default.any).isRequired,
  setSort: _propTypes.default.func,
  total: _propTypes.default.number,
  version: _propTypes.default.number
};
Datagrid.defaultProps = {
  data: {},
  hasBulkActions: false,
  ids: [],
  selectedIds: [],
  body: _react.default.createElement(_DatagridBody.default, null)
};
var _default = Datagrid;
exports.default = _default;
module.exports = exports.default;