"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _shouldUpdate = _interopRequireDefault(require("recompose/shouldUpdate"));

var _Tbody = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Tbody"));

var _classnames = _interopRequireDefault(require("classnames"));

var _DatagridRow = _interopRequireDefault(require("./DatagridRow"));

var DatagridBody = function DatagridBody(_ref) {
  var basePath = _ref.basePath,
      children = _ref.children,
      className = _ref.className,
      data = _ref.data,
      expand = _ref.expand,
      hasBulkActions = _ref.hasBulkActions,
      ids = _ref.ids,
      isLoading = _ref.isLoading,
      onToggleItem = _ref.onToggleItem,
      resource = _ref.resource,
      row = _ref.row,
      rowClick = _ref.rowClick,
      rowStyle = _ref.rowStyle,
      selectedIds = _ref.selectedIds,
      styles = _ref.styles,
      version = _ref.version,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["basePath", "children", "className", "data", "expand", "hasBulkActions", "ids", "isLoading", "onToggleItem", "resource", "row", "rowClick", "rowStyle", "selectedIds", "styles", "version"]);
  return _react.default.createElement(_Tbody.default, (0, _extends2.default)({
    className: (0, _classnames.default)('datagrid-body', className)
  }, rest), ids.map(function (id, rowIndex) {
    return _react.default.cloneElement(row, {
      basePath: basePath,
      className: className,
      expand: expand,
      hasBulkActions: hasBulkActions,
      id: id,
      key: id,
      onToggleItem: onToggleItem,
      record: data[id],
      resource: resource,
      rowClick: rowClick,
      selected: selectedIds.indexOf(id) !== -1,
      style: rowStyle ? rowStyle(data[id], rowIndex) : null
    }, children);
  }));
};

DatagridBody.propTypes = {
  basePath: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.node,
  data: _propTypes.default.object.isRequired,
  expand: _propTypes.default.node,
  hasBulkActions: _propTypes.default.bool.isRequired,
  ids: _propTypes.default.arrayOf(_propTypes.default.any).isRequired,
  isLoading: _propTypes.default.bool,
  onToggleItem: _propTypes.default.func,
  resource: _propTypes.default.string,
  row: _propTypes.default.element.isRequired,
  rowClick: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  rowStyle: _propTypes.default.func,
  selectedIds: _propTypes.default.arrayOf(_propTypes.default.any).isRequired,
  styles: _propTypes.default.object,
  version: _propTypes.default.number
};
DatagridBody.defaultProps = {
  data: {},
  hasBulkActions: false,
  ids: [],
  row: _react.default.createElement(_DatagridRow.default, null)
};

var areArraysEqual = function areArraysEqual(arr1, arr2) {
  return arr1.length == arr2.length && arr1.every(function (v, i) {
    return v === arr2[i];
  });
};

var PureDatagridBody = (0, _shouldUpdate.default)(function (props, nextProps) {
  return props.version !== nextProps.version || nextProps.isLoading === false || !areArraysEqual(props.ids, nextProps.ids) || props.data !== nextProps.data;
})(DatagridBody);
PureDatagridBody.muiName = 'TableBody';
var _default = PureDatagridBody;
exports.default = _default;
module.exports = exports.default;