"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DatagridCell = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Td = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Td"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var TdBs = (0, _styledComponents.default)(_Td.default).withConfig({
  displayName: "DatagridCell__TdBs",
  componentId: "ppu40v-0"
})(["vertical-align:middle;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;"]);

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var cellClassName = _ref.cellClassName,
      className = _ref.className,
      field = _ref.field,
      formClassName = _ref.formClassName,
      headerClassName = _ref.headerClassName,
      record = _ref.record,
      basePath = _ref.basePath,
      resource = _ref.resource,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["cellClassName", "className", "field", "formClassName", "headerClassName", "record", "basePath", "resource"]);
  return rest;
};

var DatagridCell = function DatagridCell(_ref2) {
  var className = _ref2.className,
      field = _ref2.field,
      record = _ref2.record,
      basePath = _ref2.basePath,
      resource = _ref2.resource,
      rest = (0, _objectWithoutProperties2.default)(_ref2, ["className", "field", "record", "basePath", "resource"]);
  return _react.default.createElement(TdBs, (0, _extends2.default)({
    className: (0, _classnames.default)(className, 'p-0 align-middle')
  }, sanitizeRestProps(rest)), _react.default.cloneElement(field, {
    record: record,
    basePath: field.props.basePath || basePath,
    resource: resource
  }));
};

exports.DatagridCell = DatagridCell;
DatagridCell.propTypes = {
  className: _propTypes.default.string,
  field: _propTypes.default.element,
  record: _propTypes.default.object,
  basePath: _propTypes.default.string,
  resource: _propTypes.default.string
};
DatagridCell.displayName = 'DatagridCell';
var _default = DatagridCell;
exports.default = _default;