"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DatagridHeaderCell = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _shouldUpdate = _interopRequireDefault(require("recompose/shouldUpdate"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _Th = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Th"));

var _ArrowDownward = _interopRequireDefault(require("@material-ui/icons/ArrowDownward"));

var _ArrowUpward = _interopRequireDefault(require("@material-ui/icons/ArrowUpward"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _raCore = require("ra-core");

var ThContainer = _styledComponents.default.span.withConfig({
  displayName: "DatagridHeaderCell__ThContainer",
  componentId: "c7yul9-0"
})(["cursor:pointer;display:inline-flex;align-items:center;flex-direction:inherit;justify-content:flex-start;font-size:0.75rem;font-weight:500;color:rgba(0,0,0,0.54);position:relative;user-select:none;background-color:transparent;&:hover{color:rgba(0,0,0,0.87);}&.active{color:rgba(0,0,0,0.87);}"]);

var DatagridHeaderCell = function DatagridHeaderCell(_ref) {
  var className = _ref.className,
      field = _ref.field,
      currentSort = _ref.currentSort,
      updateSort = _ref.updateSort,
      resource = _ref.resource,
      isSorting = _ref.isSorting,
      translate = _ref.translate,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["className", "field", "currentSort", "updateSort", "resource", "isSorting", "translate"]);
  return _react.default.createElement(_Th.default, (0, _extends2.default)({
    className: (0, _classnames.default)(className, field.props.headerClassName)
  }, rest), field.props.sortable !== false && (field.props.sortBy || field.props.source) ? _react.default.createElement(ThContainer, {
    role: "button",
    onClick: updateSort,
    "data-sort": field.props.source,
    className: (0, _classnames.default)({
      active: field.props.source === currentSort.field
    })
  }, _react.default.createElement(_raCore.FieldTitle, {
    label: field.props.label,
    source: field.props.source,
    resource: resource
  }), field.props.source === currentSort.field ? currentSort.order === 'ASC' ? _react.default.createElement(_ArrowUpward.default, {
    className: "ml-2"
  }) : _react.default.createElement(_ArrowDownward.default, {
    className: "ml-2"
  }) : false) : _react.default.createElement(_raCore.FieldTitle, {
    label: field.props.label,
    source: field.props.source,
    resource: resource
  }));
};

exports.DatagridHeaderCell = DatagridHeaderCell;
DatagridHeaderCell.propTypes = {
  className: _propTypes.default.string,
  field: _propTypes.default.element,
  currentSort: _propTypes.default.shape({
    sort: _propTypes.default.string,
    order: _propTypes.default.string
  }).isRequired,
  isSorting: _propTypes.default.bool,
  sortable: _propTypes.default.bool,
  resource: _propTypes.default.string,
  translate: _propTypes.default.func.isRequired,
  updateSort: _propTypes.default.func.isRequired
};
var enhance = (0, _compose.default)((0, _shouldUpdate.default)(function (props, nextProps) {
  return props.isSorting !== nextProps.isSorting || nextProps.isSorting && props.currentSort.order !== nextProps.currentSort.order;
}), _raCore.translate);

var _default = enhance(DatagridHeaderCell);

exports.default = _default;