"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _reactRouterRedux = require("react-router-redux");

var _Tr = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Tr"));

var _Td = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Td"));

var _Button = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Button"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _Label = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Label"));

var _ExpandMore = _interopRequireDefault(require("@material-ui/icons/ExpandMore"));

var _classnames = _interopRequireDefault(require("classnames"));

var _raCore = require("ra-core");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _DatagridCell = _interopRequireDefault(require("./DatagridCell"));

var FormCheckBoxBs = (0, _styledComponents.default)(_FormGroup.default).withConfig({
  displayName: "DatagridRow__FormCheckBoxBs",
  componentId: "sc-6jlc5x-0"
})(["display:inline-flex;transition:none;justify-content:center;align-items:center;width:48px;height:48px;font-size:1.5rem;text-align:center;"]);

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var basePath = _ref.basePath,
      children = _ref.children,
      className = _ref.className,
      rowClick = _ref.rowClick,
      id = _ref.id,
      isLoading = _ref.isLoading,
      onToggleItem = _ref.onToggleItem,
      push = _ref.push,
      record = _ref.record,
      resource = _ref.resource,
      selected = _ref.selected,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["basePath", "children", "className", "rowClick", "id", "isLoading", "onToggleItem", "push", "record", "resource", "selected"]);
  return rest;
};

var DatagridRow = function (_Component) {
  (0, _inherits2.default)(DatagridRow, _Component);

  function DatagridRow(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DatagridRow);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(DatagridRow).call(this, props));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleToggleExpanded", function (event) {
      _this.setState(function (state) {
        return {
          expanded: !state.expanded
        };
      });

      event.stopPropagation();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleToggle", function (event) {
      _this.props.onToggleItem(_this.props.id);

      event.stopPropagation();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleClick", (0, _asyncToGenerator2.default)(_regenerator.default.mark(function _callee() {
      var _this$props, basePath, rowClick, id, record, path;

      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$props = _this.props, basePath = _this$props.basePath, rowClick = _this$props.rowClick, id = _this$props.id, record = _this$props.record;

              if (rowClick) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return");

            case 3:
              if (!(typeof rowClick === 'function')) {
                _context.next = 9;
                break;
              }

              _context.next = 6;
              return rowClick(id, basePath, record);

            case 6:
              path = _context.sent;

              _this.handleRedirection(path);

              return _context.abrupt("return");

            case 9:
              _this.handleRedirection(rowClick);

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleRedirection", function (path) {
      var _this$props2 = _this.props,
          basePath = _this$props2.basePath,
          id = _this$props2.id,
          push = _this$props2.push;

      if (path === 'edit') {
        push((0, _raCore.linkToRecord)(basePath, id));
        return;
      }

      if (path === 'show') {
        push((0, _raCore.linkToRecord)(basePath, id, 'show'));
        return;
      }

      push(path);
    });
    _this.state = {
      expanded: false
    };
    return _this;
  }

  (0, _createClass2.default)(DatagridRow, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          basePath = _this$props3.basePath,
          children = _this$props3.children,
          className = _this$props3.className,
          expand = _this$props3.expand,
          hasBulkActions = _this$props3.hasBulkActions,
          id = _this$props3.id,
          record = _this$props3.record,
          resource = _this$props3.resource,
          selected = _this$props3.selected,
          rest = (0, _objectWithoutProperties2.default)(_this$props3, ["basePath", "children", "className", "expand", "hasBulkActions", "id", "record", "resource", "selected"]);
      var expanded = this.state.expanded;
      return _react.default.createElement(_react.Fragment, null, _react.default.createElement(_Tr.default, (0, _extends2.default)({
        className: className,
        key: id,
        onClick: this.handleClick
      }, sanitizeRestProps(rest)), expand && _react.default.createElement(_Td.default, null, _react.default.createElement(_Button.default, {
        tag: "div",
        tabIndex: -1,
        "aria-hidden": "true",
        onClick: this.handleToggleExpanded
      }, _react.default.createElement(_ExpandMore.default, null))), hasBulkActions && _react.default.createElement(_Td.default, {
        className: "p-0"
      }, _react.default.createElement(FormCheckBoxBs, {
        className: "mb-0"
      }, _react.default.createElement(_Label.default, null, _react.default.createElement(_Input.default, {
        type: "checkbox",
        className: "select-item cursor-pointer",
        checked: selected,
        onChange: this.handleToggle
      })))), _react.default.Children.map(children, function (field, index) {
        return field ? _react.default.createElement(_DatagridCell.default, (0, _extends2.default)({
          key: "".concat(id, "-").concat(field.props.source || index),
          className: (0, _classnames.default)("column-".concat(field.props.source)),
          record: record,
          id: id
        }, {
          field: field,
          basePath: basePath,
          resource: resource
        })) : null;
      })), expand && expanded && _react.default.createElement(_Tr.default, {
        key: "".concat(id, "-expand")
      }, _react.default.createElement(_Td.default, null, _react.default.cloneElement(expand, {
        record: record,
        basePath: basePath,
        resource: resource,
        id: String(id)
      }))));
    }
  }]);
  return DatagridRow;
}(_react.Component);

DatagridRow.propTypes = {
  basePath: _propTypes.default.string,
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  expand: _propTypes.default.node,
  hasBulkActions: _propTypes.default.bool.isRequired,
  id: _propTypes.default.any,
  onToggleItem: _propTypes.default.func,
  push: _propTypes.default.func,
  record: _propTypes.default.object.isRequired,
  resource: _propTypes.default.string,
  rowClick: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  selected: _propTypes.default.bool
};
DatagridRow.defaultProps = {
  hasBulkActions: false,
  record: {},
  selected: false
};
DatagridRow.displayName = 'DatagridRow';

var _default = (0, _reactRedux.connect)(null, {
  push: _reactRouterRedux.push
})(DatagridRow);

exports.default = _default;
module.exports = exports.default;