"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Filter = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _raCore = require("ra-core");

var _FilterForm = _interopRequireDefault(require("./FilterForm"));

var _FilterButton = _interopRequireDefault(require("./FilterButton"));

var Filter = function (_Component) {
  (0, _inherits2.default)(Filter, _Component);

  function Filter() {
    (0, _classCallCheck2.default)(this, Filter);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Filter).apply(this, arguments));
  }

  (0, _createClass2.default)(Filter, [{
    key: "renderButton",
    value: function renderButton() {
      var _this$props = this.props,
          context = _this$props.context,
          debounce = _this$props.debounce,
          resource = _this$props.resource,
          children = _this$props.children,
          showFilter = _this$props.showFilter,
          hideFilter = _this$props.hideFilter,
          displayedFilters = _this$props.displayedFilters,
          filterValues = _this$props.filterValues,
          rest = (0, _objectWithoutProperties2.default)(_this$props, ["context", "debounce", "resource", "children", "showFilter", "hideFilter", "displayedFilters", "filterValues"]);
      return _react.default.createElement(_FilterButton.default, (0, _extends2.default)({
        resource: resource,
        filters: _react.default.Children.toArray(children),
        showFilter: showFilter,
        displayedFilters: displayedFilters,
        filterValues: filterValues
      }, (0, _raCore.sanitizeListRestProps)(rest)));
    }
  }, {
    key: "renderForm",
    value: function renderForm() {
      var _this$props2 = this.props,
          context = _this$props2.context,
          debounce = _this$props2.debounce,
          resource = _this$props2.resource,
          children = _this$props2.children,
          hideFilter = _this$props2.hideFilter,
          displayedFilters = _this$props2.displayedFilters,
          showFilter = _this$props2.showFilter,
          filterValues = _this$props2.filterValues,
          setFilters = _this$props2.setFilters,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["context", "debounce", "resource", "children", "hideFilter", "displayedFilters", "showFilter", "filterValues", "setFilters"]);
      return _react.default.createElement(_FilterForm.default, (0, _extends2.default)({
        resource: resource,
        filters: _react.default.Children.toArray(children),
        hideFilter: hideFilter,
        displayedFilters: displayedFilters,
        initialValues: filterValues,
        setFilters: setFilters
      }, (0, _raCore.sanitizeListRestProps)(rest)));
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.context === 'button' ? this.renderButton() : this.renderForm();
    }
  }]);
  return Filter;
}(_react.Component);

exports.Filter = Filter;
Filter.propTypes = {
  children: _propTypes.default.node,
  context: _propTypes.default.oneOf(['form', 'button']),
  debounce: _propTypes.default.number.isRequired,
  displayedFilters: _propTypes.default.object,
  filterValues: _propTypes.default.object,
  hideFilter: _propTypes.default.func,
  setFilters: _propTypes.default.func,
  showFilter: _propTypes.default.func,
  resource: _propTypes.default.string.isRequired
};
Filter.defaultProps = {
  debounce: 500
};
var _default = Filter;
exports.default = _default;