"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.FilterButton = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FilterList = _interopRequireDefault(require("@material-ui/icons/FilterList"));

var _ButtonDropdown = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Button/ButtonDropdown"));

var _DropdownMenu = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Dropdown/DropdownMenu"));

var _classnames = _interopRequireDefault(require("classnames"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _raCore = require("ra-core");

var _FilterButtonMenuItem = _interopRequireDefault(require("./FilterButtonMenuItem"));

var _Button = _interopRequireDefault(require("../button/Button"));

var FilterButton = function (_Component) {
  (0, _inherits2.default)(FilterButton, _Component);

  function FilterButton(props) {
    var _this;

    (0, _classCallCheck2.default)(this, FilterButton);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(FilterButton).call(this, props));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "button", null);
    _this.state = {
      open: false
    };
    _this.handleClickButton = _this.handleClickButton.bind((0, _assertThisInitialized2.default)(_this));
    _this.handleRequestClose = _this.handleRequestClose.bind((0, _assertThisInitialized2.default)(_this));
    _this.handleShow = _this.handleShow.bind((0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(FilterButton, [{
    key: "getHiddenFilters",
    value: function getHiddenFilters() {
      var _this$props = this.props,
          filters = _this$props.filters,
          displayedFilters = _this$props.displayedFilters,
          filterValues = _this$props.filterValues;
      return filters.filter(function (filterElement) {
        return !filterElement.props.alwaysOn && !displayedFilters[filterElement.props.source] && !filterValues[filterElement.props.source];
      });
    }
  }, {
    key: "handleClickButton",
    value: function handleClickButton(event) {
      event && event.preventDefault();
      this.setState({
        open: !this.state.open
      });
    }
  }, {
    key: "handleRequestClose",
    value: function handleRequestClose() {
      this.setState({
        open: false
      });
    }
  }, {
    key: "handleShow",
    value: function handleShow(_ref) {
      var source = _ref.source,
          defaultValue = _ref.defaultValue;
      this.props.showFilter(source, defaultValue);
      this.setState({
        open: false
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var hiddenFilters = this.getHiddenFilters();
      var _this$props2 = this.props,
          className = _this$props2.className,
          resource = _this$props2.resource,
          showFilter = _this$props2.showFilter,
          displayedFilters = _this$props2.displayedFilters,
          filterValues = _this$props2.filterValues,
          translate = _this$props2.translate,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["className", "resource", "showFilter", "displayedFilters", "filterValues", "translate"]);
      var open = this.state.open;
      return hiddenFilters.length > 0 && _react.default.createElement(_ButtonDropdown.default, (0, _extends2.default)({
        className: (0, _classnames.default)('d-inline-block', className),
        isOpen: open,
        toggle: this.handleClickButton
      }, rest), _react.default.createElement(_Button.default, {
        className: "add-filter h-100 cursor-pointer",
        onClick: this.handleClickButton,
        label: "ra.action.add_filter"
      }, _react.default.createElement(_FilterList.default, null)), _react.default.createElement(_DropdownMenu.default, {
        right: true
      }, hiddenFilters.map(function (filterElement) {
        return _react.default.createElement(_FilterButtonMenuItem.default, {
          key: filterElement.props.source,
          filter: filterElement.props,
          resource: resource,
          onShow: _this2.handleShow,
          className: "cursor-pointer"
        });
      })));
    }
  }]);
  return FilterButton;
}(_react.Component);

exports.FilterButton = FilterButton;
FilterButton.propTypes = {
  resource: _propTypes.default.string.isRequired,
  filters: _propTypes.default.arrayOf(_propTypes.default.node).isRequired,
  displayedFilters: _propTypes.default.object.isRequired,
  filterValues: _propTypes.default.object.isRequired,
  showFilter: _propTypes.default.func.isRequired,
  translate: _propTypes.default.func.isRequired,
  className: _propTypes.default.string
};

var _default = (0, _compose.default)(_raCore.translate)(FilterButton);

exports.default = _default;