"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.mergeInitialValuesWithDefaultValues = exports.FilterForm = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reduxForm = require("redux-form");

var _Form = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _withProps = _interopRequireDefault(require("recompose/withProps"));

var _set = _interopRequireDefault(require("lodash/set"));

var _FilterFormInput = _interopRequireDefault(require("./FilterFormInput"));

var Form = (0, _styledComponents.default)(_Form.default).withConfig({
  displayName: "FilterForm__Form",
  componentId: "sc-36vfp9-0"
})(["display:flex;flex-wrap:wrap;padding-top:0;align-items:flex-end;"]);

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var anyTouched = _ref.anyTouched,
      asyncValidate = _ref.asyncValidate,
      asyncValidating = _ref.asyncValidating,
      autofill = _ref.autofill,
      blur = _ref.blur,
      change = _ref.change,
      clearAsyncError = _ref.clearAsyncError,
      clearFields = _ref.clearFields,
      clearSubmit = _ref.clearSubmit,
      clearSubmitErrors = _ref.clearSubmitErrors,
      destroy = _ref.destroy,
      dirty = _ref.dirty,
      dispatch = _ref.dispatch,
      displayedFilters = _ref.displayedFilters,
      filterValues = _ref.filterValues,
      handleSubmit = _ref.handleSubmit,
      hideFilter = _ref.hideFilter,
      initialize = _ref.initialize,
      initialized = _ref.initialized,
      initialValues = _ref.initialValues,
      invalid = _ref.invalid,
      pristine = _ref.pristine,
      pure = _ref.pure,
      reset = _ref.reset,
      resetSection = _ref.resetSection,
      save = _ref.save,
      setFilter = _ref.setFilter,
      setFilters = _ref.setFilters,
      submit = _ref.submit,
      submitFailed = _ref.submitFailed,
      submitSucceeded = _ref.submitSucceeded,
      submitting = _ref.submitting,
      touch = _ref.touch,
      triggerSubmit = _ref.triggerSubmit,
      untouch = _ref.untouch,
      valid = _ref.valid,
      validate = _ref.validate,
      props = (0, _objectWithoutProperties2.default)(_ref, ["anyTouched", "asyncValidate", "asyncValidating", "autofill", "blur", "change", "clearAsyncError", "clearFields", "clearSubmit", "clearSubmitErrors", "destroy", "dirty", "dispatch", "displayedFilters", "filterValues", "handleSubmit", "hideFilter", "initialize", "initialized", "initialValues", "invalid", "pristine", "pure", "reset", "resetSection", "save", "setFilter", "setFilters", "submit", "submitFailed", "submitSucceeded", "submitting", "touch", "triggerSubmit", "untouch", "valid", "validate"]);
  return props;
};

var FilterForm = function (_Component) {
  (0, _inherits2.default)(FilterForm, _Component);

  function FilterForm() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, FilterForm);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(FilterForm)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleHide", function (event) {
      return _this.props.hideFilter(event.currentTarget.dataset.key);
    });
    return _this;
  }

  (0, _createClass2.default)(FilterForm, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.filters.forEach(function (filter) {
        if (filter.props.alwaysOn && filter.props.defaultValue) {
          throw new Error('Cannot use alwaysOn and defaultValue on a filter input. Please set the filterDefaultValues props on the <List> element instead.');
        }
      });
    }
  }, {
    key: "getShownFilters",
    value: function getShownFilters() {
      var _this$props = this.props,
          filters = _this$props.filters,
          displayedFilters = _this$props.displayedFilters,
          initialValues = _this$props.initialValues;
      return filters.filter(function (filterElement) {
        return filterElement.props.alwaysOn || displayedFilters[filterElement.props.source] || typeof initialValues[filterElement.props.source] !== 'undefined';
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          resource = _this$props2.resource,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, ["className", "resource"]);
      return _react.default.createElement(Form, (0, _extends2.default)({
        tag: "div",
        className: className
      }, sanitizeRestProps(rest)), this.getShownFilters().map(function (filterElement) {
        return _react.default.createElement(_FilterFormInput.default, {
          key: filterElement.props.source,
          filterElement: filterElement,
          handleHide: _this2.handleHide,
          resource: resource
        });
      }), _react.default.createElement("div", null));
    }
  }]);
  return FilterForm;
}(_react.Component);

exports.FilterForm = FilterForm;
FilterForm.propTypes = {
  resource: _propTypes.default.string.isRequired,
  filters: _propTypes.default.arrayOf(_propTypes.default.node).isRequired,
  displayedFilters: _propTypes.default.object.isRequired,
  hideFilter: _propTypes.default.func.isRequired,
  initialValues: _propTypes.default.object,
  className: _propTypes.default.string
};

var mergeInitialValuesWithDefaultValues = function mergeInitialValuesWithDefaultValues(_ref2) {
  var initialValues = _ref2.initialValues,
      filters = _ref2.filters;
  return {
    initialValues: (0, _objectSpread2.default)({}, filters.filter(function (filterElement) {
      return filterElement.props.alwaysOn && filterElement.props.defaultValue;
    }).reduce(function (acc, filterElement) {
      return (0, _set.default)((0, _objectSpread2.default)({}, acc), filterElement.props.source, filterElement.props.defaultValue);
    }, {}), initialValues)
  };
};

exports.mergeInitialValuesWithDefaultValues = mergeInitialValuesWithDefaultValues;
var enhance = (0, _compose.default)((0, _withProps.default)(mergeInitialValuesWithDefaultValues), (0, _reduxForm.reduxForm)({
  form: 'filterForm',
  enableReinitialize: true,
  destroyOnUnmount: false,
  onChange: function onChange(values, dispatch, props) {
    return props && props.setFilters(values);
  }
}));

var _default = enhance(FilterForm);

exports.default = _default;