"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reduxForm = require("redux-form");

var _HighlightOff = _interopRequireDefault(require("@material-ui/icons/HighlightOff"));

var _raCore = require("ra-core");

var _Button = _interopRequireDefault(require("../button/Button"));

var emptyRecord = {};

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var alwaysOn = _ref.alwaysOn,
      props = (0, _objectWithoutProperties2.default)(_ref, ["alwaysOn"]);
  return props;
};

var FilterFormInput = function FilterFormInput(_ref2) {
  var filterElement = _ref2.filterElement,
      handleHide = _ref2.handleHide,
      resource = _ref2.resource,
      translate = _ref2.translate;
  return _react.default.createElement("div", {
    "data-source": filterElement.props.source,
    className: "filter-field mx-2 align-items-center my-3 d-flex"
  }, !filterElement.props.alwaysOn && _react.default.createElement(_Button.default, {
    className: "hide-filter cursor-pointer d-flex",
    size: "sm",
    onClick: handleHide,
    "data-key": filterElement.props.source,
    tooltip: translate('ra.action.remove_filter')
  }, _react.default.createElement(_HighlightOff.default, null)), _react.default.createElement(_reduxForm.Field, (0, _extends2.default)({
    allowEmpty: true
  }, sanitizeRestProps(filterElement.props), {
    name: filterElement.props.source,
    component: filterElement.type,
    resource: resource,
    record: emptyRecord
  })), _react.default.createElement("div", null, "\xA0"));
};

FilterFormInput.propTypes = {
  filterElement: _propTypes.default.node,
  handleHide: _propTypes.default.func,
  resource: _propTypes.default.string,
  translate: _propTypes.default.func
};

var _default = (0, _raCore.translate)(FilterFormInput);

exports.default = _default;
module.exports = exports.default;