"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _onlyUpdateForKeys = _interopRequireDefault(require("recompose/onlyUpdateForKeys"));

var _raCore = require("ra-core");

var _CardActions = _interopRequireDefault(require("../layout/CardActions"));

var _button = require("../button");

var Actions = function Actions(_ref) {
  var bulkActions = _ref.bulkActions,
      currentSort = _ref.currentSort,
      className = _ref.className,
      resource = _ref.resource,
      filters = _ref.filters,
      displayedFilters = _ref.displayedFilters,
      exporter = _ref.exporter,
      filterValues = _ref.filterValues,
      hasCreate = _ref.hasCreate,
      basePath = _ref.basePath,
      selectedIds = _ref.selectedIds,
      onUnselectItems = _ref.onUnselectItems,
      showFilter = _ref.showFilter,
      total = _ref.total,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["bulkActions", "currentSort", "className", "resource", "filters", "displayedFilters", "exporter", "filterValues", "hasCreate", "basePath", "selectedIds", "onUnselectItems", "showFilter", "total"]);
  return _react.default.createElement(_CardActions.default, (0, _extends2.default)({
    className: className
  }, (0, _raCore.sanitizeListRestProps)(rest)), bulkActions && (0, _react.cloneElement)(bulkActions, {
    basePath: basePath,
    filterValues: filterValues,
    resource: resource,
    selectedIds: selectedIds,
    onUnselectItems: onUnselectItems
  }), filters && (0, _react.cloneElement)(filters, {
    resource: resource,
    showFilter: showFilter,
    displayedFilters: displayedFilters,
    filterValues: filterValues,
    context: 'button'
  }), hasCreate && _react.default.createElement(_button.CreateButton, {
    basePath: basePath
  }), exporter !== false && _react.default.createElement(_button.ExportButton, {
    disabled: total === 0,
    resource: resource,
    sort: currentSort,
    filter: filterValues,
    exporter: exporter
  }));
};

Actions.propTypes = {
  bulkActions: _propTypes.default.oneOfType([_propTypes.default.element, _propTypes.default.bool]),
  basePath: _propTypes.default.string,
  className: _propTypes.default.string,
  currentSort: _propTypes.default.object,
  displayedFilters: _propTypes.default.object,
  exporter: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.bool]),
  filters: _propTypes.default.element,
  filterValues: _propTypes.default.object,
  hasCreate: _propTypes.default.bool,
  resource: _propTypes.default.string,
  onUnselectItems: _propTypes.default.func.isRequired,
  selectedIds: _propTypes.default.arrayOf(_propTypes.default.any),
  showFilter: _propTypes.default.func,
  total: _propTypes.default.number.isRequired
};
Actions.defaultProps = {
  selectedIds: []
};

var _default = (0, _onlyUpdateForKeys.default)(['resource', 'filters', 'displayedFilters', 'filterValues', 'selectedIds'])(Actions);

exports.default = _default;
module.exports = exports.default;