"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _breakpoints = require("@bootstrap-styled/css-mixins/lib/breakpoints");

var Toolbar = _styledComponents.default.div.withConfig({
  displayName: "ListToolbar__Toolbar",
  componentId: "sc-1ehfwuh-0"
})(["", ""], function (props) {
  return "\n    display: flex;\n    position: relative;\n    align-items: center;\n    justify-content: space-between;\n    padding: 0 16px;\n    min-height: 56px;\n    ".concat((0, _breakpoints.mediaBreakpointDown)('sm', props.theme['$grid-breakpoints'], "\n      padding: 0 24px;\n      min-height: 64px;\n    "), "\n  ");
});

var ListToolbar = function ListToolbar(_ref) {
  var filters = _ref.filters,
      actions = _ref.actions,
      bulkActions = _ref.bulkActions,
      exporter = _ref.exporter,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["filters", "actions", "bulkActions", "exporter"]);
  return _react.default.createElement(Toolbar, null, filters && _react.default.cloneElement(filters, (0, _objectSpread2.default)({}, rest, {
    context: 'form'
  })), _react.default.createElement("span", null), actions && _react.default.cloneElement(actions, (0, _objectSpread2.default)({}, rest, {
    bulkActions: bulkActions,
    exporter: exporter,
    filters: filters
  })));
};

ListToolbar.propTypes = {
  filters: _propTypes.default.element,
  actions: _propTypes.default.element,
  bulkActions: _propTypes.default.oneOfType([_propTypes.default.element, _propTypes.default.bool]),
  exporter: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.bool])
};
var _default = ListToolbar;
exports.default = _default;
module.exports = exports.default;