"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _Datagrid = _interopRequireDefault(require("./Datagrid"));

var _SingleFieldList = _interopRequireDefault(require("./SingleFieldList"));

var _ArrayField = _interopRequireDefault(require("../field/ArrayField"));

var _BooleanField = _interopRequireDefault(require("../field/BooleanField"));

var _ChipField = _interopRequireDefault(require("../field/ChipField"));

var _DateField = _interopRequireDefault(require("../field/DateField"));

var _EmailField = _interopRequireDefault(require("../field/EmailField"));

var _NumberField = _interopRequireDefault(require("../field/NumberField"));

var _ReferenceField = _interopRequireDefault(require("../field/ReferenceField"));

var _ReferenceArrayField = _interopRequireDefault(require("../field/ReferenceArrayField"));

var _TextField = _interopRequireDefault(require("../field/TextField"));

var _UrlField = _interopRequireDefault(require("../field/UrlField"));

var _default = {
  table: {
    component: function component(props) {
      return _react.default.createElement(_Datagrid.default, (0, _extends2.default)({
        rowClick: "edit"
      }, props));
    },
    representation: function representation(_, children) {
      return "        <Datagrid rowClick=\"edit\">\n".concat(children.map(function (child) {
        return "            ".concat(child.getRepresentation());
      }).join('\n'), "\n        </Datagrid>");
    }
  },
  array: {
    component: function component(_ref) {
      var children = _ref.children,
          props = (0, _objectWithoutProperties2.default)(_ref, ["children"]);
      return _react.default.createElement(_ArrayField.default, props, _react.default.createElement(_SingleFieldList.default, null, _react.default.createElement(_ChipField.default, {
        source: children.length > 0 && children[0].props.source
      })));
    },
    representation: function representation(props, children) {
      return "<ArrayField source=\"".concat(props.source, "\"><SingleFieldList><ChipField source=\"").concat(children.length > 0 && children[0].getProps().source, "\" /></SingleFieldList></ArrayField>");
    }
  },
  boolean: {
    component: _BooleanField.default,
    representation: function representation(props) {
      return "<BooleanField source=\"".concat(props.source, "\" />");
    }
  },
  date: {
    component: _DateField.default,
    representation: function representation(props) {
      return "<DateField source=\"".concat(props.source, "\" />");
    }
  },
  email: {
    component: _EmailField.default,
    representation: function representation(props) {
      return "<EmailField source=\"".concat(props.source, "\" />");
    }
  },
  id: {
    component: _TextField.default,
    representation: function representation(props) {
      return "<TextField source=\"".concat(props.source, "\" />");
    }
  },
  number: {
    component: _NumberField.default,
    representation: function representation(props) {
      return "<NumberField source=\"".concat(props.source, "\" />");
    }
  },
  reference: {
    component: _ReferenceField.default,
    representation: function representation(props) {
      return "<ReferenceField source=\"".concat(props.source, "\" reference=\"").concat(props.reference, "\"><TextField source=\"id\" /></ReferenceField>");
    }
  },
  referenceChild: {
    component: function component(props) {
      return _react.default.createElement(_TextField.default, (0, _extends2.default)({
        source: "id"
      }, props));
    },
    representation: function representation() {
      return "<TextField source=\"id\" />";
    }
  },
  referenceArray: {
    component: _ReferenceArrayField.default,
    representation: function representation(props) {
      return "<ReferenceArrayField source=\"".concat(props.source, "\" reference=\"").concat(props.reference, "\"><TextField source=\"id\" /></ReferenceArrayField>");
    }
  },
  referenceArrayChild: {
    component: function component(props) {
      return _react.default.createElement(_TextField.default, (0, _extends2.default)({
        source: "id"
      }, props));
    },
    representation: function representation() {
      return "<TextField source=\"id\" />";
    }
  },
  richText: false,
  string: {
    component: _TextField.default,
    representation: function representation(props) {
      return "<TextField source=\"".concat(props.source, "\" />");
    }
  },
  url: {
    component: _UrlField.default,
    representation: function representation(props) {
      return "<UrlField source=\"".concat(props.source, "\" />");
    }
  }
};
exports.default = _default;
module.exports = exports.default;