"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.regexDoesNotContain = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var isEmpty = function isEmpty(value) {
  return typeof value === 'undefined' || value === null || value === '';
};

var getMessage = function getMessage(message, messageArgs, value, values, props) {
  return typeof message === 'function' ? message((0, _objectSpread2.default)({
    args: messageArgs,
    value: value,
    values: values
  }, props)) : props.translate(message, (0, _objectSpread2.default)({
    _: message
  }, messageArgs));
};

var regexDoesNotContain = function regexDoesNotContain(pattern) {
  var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'ra.validation.regex.doesNotContain';
  return function (value, values, props) {
    return !isEmpty(value) && typeof value === 'string' && pattern.test(value) ? getMessage(message, {
      pattern: pattern
    }, value, values, props) : undefined;
  };
};

exports.regexDoesNotContain = regexDoesNotContain;